-- Dominicus' DomDom World of Warcarft MOD version 0.1
-- Sounds borrowed (hijacked) from every available sound MOD at curse.com
-- Original Addon: Imbasounds, made by Gimph @ Vashj (EU)
-- Credit goes to LeeroyHillCatsPower / FunnySounds - Revamped / MortalKombat SoundMod / UT Sounds, and various sounds found on the internet!


-- immediate needs
-- must be able to force that previous sound packs are active, and that all the sound packs up to a certain number are required by an alphabetical value in the dd guild information tab's code.
-- must perform a full sort on the sound list
-- must make it so that the menu list system does not show the number on the "/dd l" index pages, so you have to browse by alphabetical instead of by number.
-- need a system to search for a sound with a text string
-- need to be able to properly handle if a soundfile entry does not exist, but the mod recieves a command to play that non-existant (monkey in the middle) number anyway.


function retardo(input)

end


-- INFORMATION
-- 1. DomDom is compatible with .wav and .mp3 files, however the input compression and datarates are unknown.


-- CONSTANTS
-- debug constant, when set to 1, will show debug messages, else when set 0, will not show debug messages
local DEBUG = 0;
--definre the module name
local MODULE_NAME = "DomDom"
--The following line, fetchs the version number from the .xml file.
--local MODULE_VERSION = strmatch(GetAddOnMetadata(MODULE_NAME, "version"), "^([%d.]+)")
local MODULE_VERSION = "083"
-- define the number of sounds per section
local SOUNDS_PER_LISTBLOCK = 25
-- the number of ranks below guildmaster that can spam guild sounds
local RANKS_BELOW_GUILDMASTER_THAT_CAN_SPAM_GUILD_SOUNDS = 0

if _G.GetNumPartyMembers == nil then
	function GetNumPartyMembers()
		return 5
	end
	_G.GetNumPartyMembers = GetNumPartyMembers
end


-- GLOBALS
transmissionType = ""
transmissionTarget = ""
itemNumberToTransmitForPlay = 0
modCommunicationKey = "DomDomV2"
globalMute = 0 -- global mute is disabled by default
globalMuteText = "" -- "]-MUTED-[ " when active
authorizedToUseThisMod = 0 -- default to being disabled
modHasBeenActivated = 0 -- default to being disabled, This value is what the other sound packs monitor for, to know when to include their sounds into the main pool.
modVersionIsUpToDate = 0 -- default the mod to not being up to date, unless specifically confirmed
modNewestVersion = "improperly installed"
-- variables used for holding the version number of the soundpacks being reported from the sound packs themselves
-- DO NOT ALTER THE ITEMS BELOW THIS
DDSoundPack01_Version_Discovered = 0;
DDSoundPack02_Version_Discovered = 0;
DDSoundPack03_Version_Discovered = 0;
DDSoundPack04_Version_Discovered = 0;
DDSoundPack05_Version_Discovered = 0;
DDSoundPack06_Version_Discovered = 0;
DDSoundPack07_Version_Discovered = 0;
DDSoundPack08_Version_Discovered = 0;
DDSoundPack09_Version_Discovered = 0;
-- DO NOT ALTER THE ITEMS ABOVE THIS
-- tracks whether or not any of the dom dom sound packs need to be updated
DDSoundPacksNeedToBeUpdated = 0;

-- LOCAL VARIABLES
-- define the soundFilePath
local soundFilePath = "Interface\\AddOns\\DomDom\\Data\\"
--local soundFilePath = "Interface\\AddOns\\DomDom_SoundPack01\\Data\\"
-- define the number of items in the masterSoundTable
local itemsInMasterSoundTable = 0
--get the number of guild members in the guild
if ( IsInGuild() ) then
	local numGuildMembers = GetNumGuildMembers()
else
	local numGuildMembers = 0
end
-- define the masterSoundTable
local masterSoundTable = {}
-- define the masterSoundTable
local masterSoundBinaryTable = {}
-- define the current realm
thisRealm = GetRealmName()
-- define the current player
local thisPlayer = UnitName("player")
-- define the guild information for this player
guildName, guildRankName, guildRankIndex = nil
-- define the variable to hold the guild information button text
guildInformation = nil
-- define the DD_TimeTilNext variable by assigning the unix epcoh in seconds that is returned from time()
local DD_TimeTilNext = time()
local DD_skipNext = 0
local emotehistory = {}
-- counter variable used to store the current number of sound items to be stepped through to test each and every sound with someone
local currentSoundToStepThrough = 1;
local guildUsableRank = 0;
-- holds the DomDomSoundPack numbers with the required versions of each
DDSoundPack01_Version_Required = 82;
DDSoundPack02_Version_Required = 82;
DDSoundPack03_Version_Required = 0;
DDSoundPack04_Version_Required = 0;
DDSoundPack05_Version_Required = 0;
DDSoundPack06_Version_Required = 0;
DDSoundPack07_Version_Required = 0;
DDSoundPack08_Version_Required = 0;
DDSoundPack09_Version_Required = 0;
-- randomLowerLimit soud number
local randomLowerLimit = 2

if C_ChatInfo then
	C_ChatInfo.RegisterAddonMessagePrefix(modCommunicationKey)
else
	RegisterAddonMessagePrefix(modCommunicationKey)
end


-- FUNCTIONS
function DD_MultiVersionCheck() -- /script DD_MultiVersionCheck();
	local temp_ThingsNeedingUpdating = "We're sorry, but your DomDom mod is out of date. Please re-download and install the latest version of the following DomDomSoundPacks from Curse.com, and restart WoW:\n"
	if (DDSoundPack01_Version_Discovered > 0 and DDSoundPack01_Version_Discovered < DDSoundPack01_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack01\n";
	end
	if (DDSoundPack02_Version_Discovered > 0 and DDSoundPack02_Version_Discovered < DDSoundPack02_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack02\n";
	end
	if (DDSoundPack03_Version_Discovered > 0 and DDSoundPack03_Version_Discovered < DDSoundPack03_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack03\n";
	end
	if (DDSoundPack04_Version_Discovered > 0 and DDSoundPack04_Version_Discovered < DDSoundPack04_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack04\n";
	end
	if (DDSoundPack05_Version_Discovered > 0 and DDSoundPack05_Version_Discovered < DDSoundPack05_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack05\n";
	end
	if (DDSoundPack06_Version_Discovered > 0 and DDSoundPack06_Version_Discovered < DDSoundPack06_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack06\n";
	end
	if (DDSoundPack07_Version_Discovered > 0 and DDSoundPack07_Version_Discovered < DDSoundPack07_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack07\n";
	end
	if (DDSoundPack08_Version_Discovered > 0 and DDSoundPack08_Version_Discovered < DDSoundPack08_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack08\n";
	end
	if (DDSoundPack09_Version_Discovered > 0 and DDSoundPack09_Version_Discovered < DDSoundPack09_Version_Required) then
		temp_DDSoundPacksNeedToBeUpdated = 1;
		temp_ThingsNeedingUpdating = temp_ThingsNeedingUpdating .. " ---> DomDom_SoundPack09\n";
	end
	if (temp_DDSoundPacksNeedToBeUpdated == 1) then
		DEFAULT_CHAT_FRAME:AddMessage(temp_ThingsNeedingUpdating,1,0,0)
	end
end

function DD_OnLoad()
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DD_OnLoad")
	end

	 DD_OnEventcore:RegisterEvent("ADDON_LOADED")
	 DD_OnEventcore:RegisterEvent("VARIABLES_LOADED")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_ADDON")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_EMOTE")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_SAY")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_RAID")
	 --DD_OnEventcore:RegisterEvent("CHAT_MSG_BATTLEGROUND")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_YELL")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_SYSTEM")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_WHISPER")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_GUILD")
	 DD_OnEventcore:RegisterEvent("CHAT_MSG_PARTY")
	 DD_OnEventcore:RegisterEvent("GUILD_ROSTER_UPDATE")
	 DD_OnEventcore:RegisterEvent("RAID_ROSTER_UPDATE")
	 DD_OnEventcore:RegisterEvent("PARTY_LEADER_CHANGED")
	 --DD_OnEventcore:RegisterEvent("PARTY_MEMBERS_CHANGED")
	 DD_OnEventcore:RegisterEvent("PLAYER_GUILD_UPDATE")
	 DD_OnEventcore:RegisterEvent("PLAYER_ENTERING_WORLD")

end

function toggleGlobalMute()
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION toggleGlobalMute")
	end
	if globalMute == 0 then
		-- enable global mute
		globalMute = 1
		globalMuteText = "  <--MUTED-->  "
		DEFAULT_CHAT_FRAME:AddMessage("DD is now globally muted. You will no longer be able to play, send, or receive sounds.",1,.25,1)
	elseif globalMute == 1 then
		-- disable global mute
		globalMute = 0
		globalMuteText = ""
		DEFAULT_CHAT_FRAME:AddMessage("DD is now globally unmuted. You will now be able to play, send, and receive sounds.",1,.25,1)
	end
end

-- DomDom used to use the key for sending message, this wrapper function moves the command from
-- the addon tag to the message
function SendDomDomAddonMessage(tag, message, transmissionType, transmissionTarget)
	if _G.C_ChatInfo then
		_G.C_ChatInfo.SendAddonMessage(modCommunicationKey, tag .. "^" .. message, transmissionType, transmissionTarget)
	else
		_G.SendAddonMessage(modCommunicationKey, tag .. "^" .. message, transmissionType, transmissionTarget)
	end
end

function sendDDVersionRequestGuild() -- send the message
	SendDomDomAddonMessage("versionrequest", "", GUILD)
end

function sendDDVersionRequestRaid() -- send the message
	SendDomDomAddonMessage("versionrequest", "", RAID)
end

function sendDDVersionRequestBG() -- send the message
	SendDomDomAddonMessage("versionrequest", "", BATTLEGROUND)
end

function sendDDVersionRequestParty() -- send the message
	SendDomDomAddonMessage("versionrequest", "", PARTY)
end

function sendDDLatencyRequestGuild()
	SendDomDomAddonMessage("latencyrequest", "", GUILD)
end

function sendDDLatencyRequestRaid()
	SendDomDomAddonMessage("latencyrequest", "", RAID)
end

function sendDDfpsRequestGuild()
	SendDomDomAddonMessage("fpsrequest", "", GUILD)
end

function sendDDfpsRequestRaid()
	SendDomDomAddonMessage("fpsrequest", "", RAID)
end

function sendDDfpsRequestParty()
	SendDomDomAddonMessage("fpsrequest", "", PARTY)
end

function sendDDfpsRequestBG()
	SendDomDomAddonMessage("fpsrequest", "", BATTLEGROUND)
end

function insertTheSoundFiles()
	-- insert the base sound file
	insertSoundFile(0,1,"__This is a test sound.mp3", "")

	-- additional sounds from the other soundpacks for this mod will be inserted at a later moment, when they detect that this mod has come fully online.
end

function updateMasterSoundTableItemCount()
	-- # is the operator that says to return the number of elements
	itemsInMasterSoundTable = # masterSoundTable
end

function insertSoundFile(local_soundPack, local_soundNumber, local_fileName, local_emote)
	-- insert a sound file into the masterSoundTable

	--table.bininsert(masterSoundTable, "k")

	--EXAMPLE 	insertSoundFile(1,2,"_A ninja does not allow himself to be swayed by emotion, you are not worthy.mp3", "")
	--------table.bininsert(masterSoundTable, {   ["soundFile"] = local_fileName, ["soundPack"] = local_soundPack, ["soundNumber"] = local_soundNumber, ["emote"] = local_emote   })
	tinsert(masterSoundTable, {   ["soundPack"] = local_soundPack, ["soundNumber"] = local_soundNumber, ["soundFile"] = local_fileName, ["emote"] = local_emote   })

	updateMasterSoundTableItemCount()
	--DEFAULT_CHAT_FRAME:AddMessage("Items Currently In The Sound File Table: " .. itemsInMasterSoundTable)
end

function DDTransmitSound(inputFileSoundNumberToPlay3)


	local _,_,inputFileSoundNumberToPlay3,parameters = string.find(inputFileSoundNumberToPlay3, "^%s*([^%s]+)%s*(.*)$")
	--command = strlower(itemNumber or "")
	--parameters = strlower(parameters or "")
	inputFileSoundNumberToPlay3 = tonumber(inputFileSoundNumberToPlay3)
	--parameters = strlower(parameters or "")

	if inputFileSoundNumberToPlay3 > 0 and inputFileSoundNumberToPlay3 <= itemsInMasterSoundTable then --sound number is in the expected range
		if not ( floor(inputFileSoundNumberToPlay3) == inputFileSoundNumberToPlay3 ) then -- catches the numbers that are not integers
			--displaySoundNumberNotIntegerErrorMessage(itemNumber) -- throws an error message
			-- do nothing, because we received this sound number, and it's not valid
		else
			local soundItem = masterSoundTable[ inputFileSoundNumberToPlay3 ]
			itemNumberToTransmitForPlay = inputFileSoundNumberToPlay3

			--local soundNumber = soundItem[1]
			local soundFileNamePath = soundFilePath .. soundItem["soundFile"]

			if DEBUG >= 1 then
				--DEFAULT_CHAT_FRAME:AddMessage("soundNumber: " .. soundNumber)
				DEFAULT_CHAT_FRAME:AddMessage("soundFileName: " .. soundFileNamePath)
			end

			-- play the specific sound number
			--PlaySoundFile(soundFilePath .. soundFileName)

			if DEBUG >= 1 then
				DEFAULT_CHAT_FRAME:AddMessage("===== soundNumber: " .. inputFileSoundNumberToPlay3 .. ", transmissionType: " .. transmissionType .. ", transmissionTarget: " .. transmissionTarget)
			end

			if globalMute == 0 then
				if transmissionType == "WHISPER" then
					--if transmissionTarget == thisPlayer then
						SendDomDomAddonMessage("soundToPlay", inputFileSoundNumberToPlay3, transmissionType, transmissionTarget)
					--else
					--	DD_playThisSoundFile(inputFileSoundNumberToPlay3)
					--	SendDomDomAddonMessage("soundToPlay", inputFileSoundNumberToPlay3, transmissionType, transmissionTarget)
					--end
				else
					SendDomDomAddonMessage("soundToPlay", inputFileSoundNumberToPlay3, transmissionType)
				end

				if DEBUG >= 1 then
					DEFAULT_CHAT_FRAME:AddMessage("===== Trasnmitted sound #: " .. inputFileSoundNumberToPlay3)
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Your sounds aren't being transmitted, because you have are still globally muted. Enter \"/dd mute\" to unmute it.",1,0,0)
			end

			itemNumberToTransmitForPlay = 0
			transmissionTarget = ""
			transmissionType = ""
		end
	end
end

function getSoundDescription(inputItemNumber)
	local soundItem = masterSoundTable[ inputItemNumber ]
	local soundFileName = soundItem["soundFile"]
	local soundDescription = strsub(soundFileName, 1, strlen(soundFileName)-4 )

	return soundDescription
end

function DD_playThisSoundFile(inputSoundNumber)
	inputSoundNumber = tonumber(inputSoundNumber)

	if inputSoundNumber > 0 and inputSoundNumber <= itemsInMasterSoundTable then
		if not ( floor(inputSoundNumber) == inputSoundNumber ) then -- catches the numbers that are not integers
			displaySoundNumberNotIntegerErrorMessage(itemNumber) -- throws an error message
		else

			local soundItem = masterSoundTable[ inputSoundNumber ]
			local soundFileName = soundItem["soundFile"]
			local soundPack = soundItem["soundPack"]
			local soundNumber = soundItem["soundNumber"]

			if (GetCVar("Sound_EnableAllSound") == "0") then
			DEFAULT_CHAT_FRAME:AddMessage("---> DomDom needs your World of Warcraft to have it's sound system enabled. If you would like to enable it, please type: \"/dd sound\".",1,.25,.25)
				else
				-- specific soundpack sound file to play
				if (soundPack == 0) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					-- temporary workaround to the blizzard WoW 2.2 sound bug.
					--PlaySound("GLUESCREENSMALLBUTTONMOUSEDOWN")
					PlaySoundFile(soundFileNamePath)
				elseif(soundPack == 1) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack01\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack01(soundFileNamePath)
				elseif(soundPack == 2) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack02\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
						remotePlaySoundFileSoundPack02(soundFileNamePath)
				elseif(soundPack == 3) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack03\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack03(soundFileNamePath)
				elseif(soundPack == 4) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack04\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack04(soundFileNamePath)
				elseif(soundPack == 5) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack05\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack05(soundFileNamePath)
				elseif(soundPack == 6) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack06\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack06(soundFileNamePath)
				elseif(soundPack == 7) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack07\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack07(soundFileNamePath)
				elseif(soundPack == 8) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack08\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack08(soundFileNamePath)
				elseif(soundPack == 9) then
					local soundFileNamePath = "Interface\\AddOns\\DomDom_SoundPack09\\Data\\" .. soundFileName
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end
					remotePlaySoundFileSoundPack09(soundFileNamePath)
				else
					DEFAULT_CHAT_FRAME:AddMessage("*** CRITICAL DomDom Mod Error!!! ***")
				end
			end
		end
	end
end

function DDPlayHandler(command)
	local _,_,command,parameters = string.find(command, "^%s*([^%s]+)%s*(.*)$")
	command = strlower(command or "")
	--parameters = strlower(parameters or "")
	--command = tonumber(command)
	parameters = strlower(parameters or "")

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("COMMAND AREA: DDPlayHandler",1,.25,0)
	end

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("command SIGMA: " .. command)
	end

	if command == "g" then -- guild transmission
		if ( IsInGuild() ) then --check to see if the user is in a guild
			if true or ( (guildRankIndex <= guildUsableRank) and ( guildRankIndex >= 0 ) ) then
				transmissionType = "GUILD"
				if globalMute == 0 then
					--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to GUILD, Sound #: " .. itemNumberToTransmitForPlay .. " (" .. getSoundDescription(itemNumberToTransmitForPlay) .. ")",1,.25,1)
				end
				DDTransmitSound(itemNumberToTransmitForPlay)
			else
				DEFAULT_CHAT_FRAME:AddMessage("Your rank is not high enough in the guild to use that feature.",1,.25,0)
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("You need to be in a guild to do that.",1,.25,0)
		end

	elseif command  == "r" then -- raid transmission
		if ( UnitInRaid("player") ~= nil ) then
			transmissionType = "RAID"
			if globalMute == 0 then
				--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to RAID, Sound #: " .. itemNumberToTransmitForPlay .. " (" .. getSoundDescription(itemNumberToTransmitForPlay) .. ")",1,.25,1)
			end
			DDTransmitSound(itemNumberToTransmitForPlay)
		else
			DEFAULT_CHAT_FRAME:AddMessage("You need to be in a raid to do that.",1,.25,0)
		end

	elseif command  == "b" then -- battleground transmission
		if ( UnitInRaid("player") ~= nil ) then

			transmissionType = "BATTLEGROUND"
			if globalMute == 0 then
				--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to BATTLEGROUND, Sound #: " .. itemNumberToTransmitForPlay .. " (" .. getSoundDescription(itemNumberToTransmitForPlay) .. ")",1,.25,1)
			end
			DDTransmitSound(itemNumberToTransmitForPlay)
		else
			DEFAULT_CHAT_FRAME:AddMessage("You need to be in a battleground with other people in it to do that.",1,.25,0)
		end
	elseif command == "p" then -- party transmission
		numberOfPartyMembers = GetNumPartyMembers()
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Number of party members: " .. numberOfPartyMembers,1,.25,1)
		end
		if numberOfPartyMembers >= 1 then
			transmissionType = "PARTY"
			if globalMute == 0 then
				--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to PARTY, Sound #: " .. itemNumberToTransmitForPlay .. " (" .. getSoundDescription(itemNumberToTransmitForPlay) .. ")",1,.25,1)
			end
			DDTransmitSound(itemNumberToTransmitForPlay)
		else
			DEFAULT_CHAT_FRAME:AddMessage("You need to be in a party to do that.",1,.25,0)
		end

	elseif command == "w" then -- whisper transmission
		DDPlayWhisperHandler(parameters)
	elseif command == "" then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage("parameters is empty")
		end
		DDShowHelp()
	else
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage("reached ELSE clause")
		end
		DDShowHelp()
	end
end

function DDListHandler(listBlock) -- /dd l # handler
	local _,_,listBlock,parameters = string.find(listBlock, "^%s*([^%s]+)%s*(.*)$")
	listBlock = strlower(listBlock or "")
	parameters = strlower(parameters or "")
	local localSoundNumber = tonumber(listBlock)

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("COMMAND AREA: DDListHandler",1,.25,0)
	end

	if listBlock == "" or localSoundNumber == nil then
		DDShowListblocks()
		--DDShowHelp()
	elseif localSoundNumber > 0 and localSoundNumber <= (itemsInMasterSoundTable/SOUNDS_PER_LISTBLOCK + 1) then
		DDShowList(listBlock)
	else
		DDShowListblocks()
		--DDShowHelp()
	end
end

function DDCommandHandler(command) -- /dd COMMAND PARAMATERS handler
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DDCommandHandler")
	end

	local _,_,command,parameters = string.find(command, "^%s*([^%s]+)%s*(.*)$")
	command = strlower(command or "")
	parameters = strlower(parameters or "")
	local localSoundNumber = tonumber(command)

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("COMMAND AREA: DDCommandHandler",1,.25,0)
	end

	if ( IsInGuild() and modVersionIsUpToDate == 0 and 1==2) then
		if (modNewestVersion == "improperly installed") then
			DEFAULT_CHAT_FRAME:AddMessage("DomDom (DD) is not properly installed for use in this guild. Please notify your guild master or the developer.",1,.25,0)
		else
			DEFAULT_CHAT_FRAME:AddMessage("Your out of date version of DomDom (DD v" .. MODULE_VERSION .. ") has been deactivated. Please download and install the latest version of DomDom (DD v" .. modNewestVersion .. ") to continue using DomDom.",1,.25,0)
		end
	else
		DD_MultiVersionCheck() -- this will display the out of date version messages every time a DD command is used
		if (DDSoundPacksNeedToBeUpdated == 0) then
			if command == "sound" then
				toggleWowSounds()
					elseif command == "debug143" then
				if DEBUG >= 1 then
					DEBUG = 0
					DEFAULT_CHAT_FRAME:AddMessage("Debugging Now Disabled")
				elseif DEBUG == 0 then
					DEBUG = 1
					DEFAULT_CHAT_FRAME:AddMessage("Debugging Now Enabled")
				end

			elseif command == "debugplay" then

				for tempI=1,1 do
					if (currentSoundToStepThrough <= itemsInMasterSoundTable) then
						DEFAULT_CHAT_FRAME:AddMessage("*---* DomDom debugplay to you, sound item #: " .. currentSoundToStepThrough)
						SendDomDomAddonMessage("soundToPlay", currentSoundToStepThrough, "WHISPER", thisPlayer)
						currentSoundToStepThrough = currentSoundToStepThrough + 1
					else
						DEFAULT_CHAT_FRAME:AddMessage("*---* DomDom debugplay has gone through all of the sounds")
					end
				end

			elseif command == "debugnum" then
				tempVal=0
				for tempI=1,1500 do
					tempVal=tempVal + tempI
				end
				DEFAULT_CHAT_FRAME:AddMessage("*-*-* 1...1500 = " .. tempVal)
			elseif (GetCVar("Sound_EnableAllSound") == "0") then
				DEFAULT_CHAT_FRAME:AddMessage("---> DomDom needs your World of Warcraft to have it's sound system enabled. If you would like to enable it, please type: \"/dd sound\".",1,.25,.25)
			elseif command == "list" or command == "l" then
				DDListHandler(parameters)
			elseif command == "r" then
				DDRandomHandler(parameters)
			elseif command == "mute" then
				toggleGlobalMute()
			--elseif command == "gi" then
				--DDGInviteWhisperHandler(parameters)
			elseif command == "vrg" then
				if ( IsInGuild() ) then
					sendDDVersionRequestGuild()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a guild to do that.",1,.25,0)
				end
			elseif command == "vrr" then
				if ( UnitInRaid("player") ~= nil ) then
					sendDDVersionRequestRaid()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a raid to do that.",1,.25,0)
				end
			elseif command == "vrp" then
				numberOfPartyMembers = GetNumPartyMembers()
				if numberOfPartyMembers >= 1 then
					sendDDVersionRequestParty()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a party to do that.",1,.25,0)
				end
			elseif command == "vrb" then
				if ( UnitInRaid("player") ~= nil ) then
					sendDDVersionRequestBG()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a battleground with other people in it to do that.",1,.25,0)
				end
			elseif command == "latg" then
				if ( IsInGuild() ) then
					sendDDLatencyRequestGuild()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a guild to do that.",1,.25,0)
				end
			elseif command == "latr" then
				if ( UnitInRaid("player") ~= nil ) then
					sendDDLatencyRequestRaid()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a raid to do that.",1,.25,0)
				end
			elseif command == "fpsg" then
				if ( IsInGuild() ) then
					sendDDfpsRequestGuild()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a guild to do that.",1,.25,0)
				end
			elseif command == "fpsr" then
				if ( UnitInRaid("player") ~= nil ) then
					sendDDfpsRequestRaid()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a raid to do that.",1,.25,0)
				end
			elseif command == "fpsp" then
				numberOfPartyMembers = GetNumPartyMembers()
				if numberOfPartyMembers >= 1 then
					sendDDfpsRequestParty()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a party to do that.",1,.25,0)
				end
			elseif command == "fpsb" then
				if ( UnitInRaid("player") ~= nil ) then
					sendDDfpsRequestBG()
				else
					DEFAULT_CHAT_FRAME:AddMessage("You need to be in a battleground with other people in it to do that.",1,.25,0)
				end
			elseif command == "" then
				DDShowHelp()
			elseif localSoundNumber == nil then
				DDShowHelp()
			elseif localSoundNumber > 0 and localSoundNumber <= itemsInMasterSoundTable then
				if not ( floor(localSoundNumber) == localSoundNumber ) then -- catches the numbers that are not integers
					displaySoundNumberNotIntegerErrorMessage(itemNumber) -- throws an error message
				else
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("Passing off to DDPlayHandler")
					end
					itemNumberToTransmitForPlay = localSoundNumber
					DDPlayHandler(parameters)
				end
			elseif localSoundNumber > itemsInMasterSoundTable or localSoundNumber < 1 then
				displaySoundNumberOutOfRangeErrorMessage(localSoundNumber)
			else
				DDShowHelp()
			end
		end
	end
end

function DDRandomHandler(command) -- /dd random COMMAND handler
	local _,_,command,parameters = string.find(command, "^%s*([^%s]+)%s*(.*)$")
	command = strlower(command or "")
	parameters = strlower(parameters or "")

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("COMMAND AREA: DDRandomHandler",1,.25,0)
	end

	if itemsInMasterSoundTable < 1 then -- no sound files exist
		DEFAULT_CHAT_FRAME:AddMessage("No sound files exist.")
	else -- sound files exist

		local tempUpper = itemsInMasterSoundTable
		local tempRandom = random(randomLowerLimit, tempUpper)
		itemNumberToTransmitForPlay = tempRandom

		if command == "g" then -- guild transmission
			if ( IsInGuild() ) then --check to see if the user is in a guild
				--DEFAULT_CHAT_FRAME:AddMessage("guildRankIndex: " .. guildRankIndex .. "   guildUsableRank: " .. guildUsableRank,1,.25,1)
				if DEBUG >= 1 and guildRankIndex == nil then
					DEFAULT_CHAT_FRAME:AddMessage("CRAPZILLA.",1,.25,0)
				end
				if DEBUG >= 1 and guildUsableRank == nil then
					DEFAULT_CHAT_FRAME:AddMessage("FARTCOW.",1,.25,0)
				end
				if ( (guildRankIndex <= guildUsableRank) and ( guildRankIndex >= 0 ) ) then
					transmissionType = "GUILD"
					if globalMute == 0 then
						--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to GUILD, Random Sound #: " .. tempRandom .. "(" .. getSoundDescription(tempRandom) .. ")",1,.25,1)
					end
					DDTransmitSound(tempRandom)
				else
					DEFAULT_CHAT_FRAME:AddMessage("Your rank is not high enough in the guild to use that feature.",1,.25,0)
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("You need to be in a guild to do that.",1,.25,0)
			end

		elseif command == "r" then -- raid transmission
			if ( UnitInRaid("player") ~= nil ) then
				transmissionType = "RAID"
				if globalMute == 0 then
					--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to RAID, Random Sound #: " .. tempRandom .. "(" .. getSoundDescription(tempRandom) .. ")",1,.25,1)
				end
				DDTransmitSound(tempRandom)
			else
				DEFAULT_CHAT_FRAME:AddMessage("You need to be in a raid to do that.",1,.25,0)
			end
		elseif command == "b" then -- raid transmission
			if ( UnitInRaid("player") ~= nil ) then

				transmissionType = "BATTLEGROUND"
				if globalMute == 0 then
					--DEFAULT_CHAT_FRAME:AddMessage("Will say it is transmitting, even if you aren't in a BATTLEGROUND.",1,.25,1)
					--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to BATTLEGROUND, Random Sound #: " .. tempRandom .. "(" .. getSoundDescription(tempRandom) .. ")",1,.25,1)
				end
				DDTransmitSound(tempRandom)
			else
				DEFAULT_CHAT_FRAME:AddMessage("You need to be in a battleground with other people in it to do that.",1,.25,0)
			end


			elseif command == "p" then -- party transmission
			numberOfPartyMembers = GetNumPartyMembers()
			if DEBUG >= 1 then
				DEFAULT_CHAT_FRAME:AddMessage("Number of party members: " .. numberOfPartyMembers .. "(" .. getSoundDescription(tempRandom) .. ")",1,.25,1)
			end
			if numberOfPartyMembers >= 1 then
				transmissionType = "PARTY"
				if globalMute == 0 then
					--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to PARTY, Random Sound #: " .. tempRandom .. "(" .. getSoundDescription(tempRandom) .. ")",1,.25,1)
				end
				DDTransmitSound(tempRandom)
			else
				DEFAULT_CHAT_FRAME:AddMessage("You need to be in a party to do that.",1,.25,0)
			end
		elseif command == "w" then -- whisper transmission
			DDRandomWhisperHandler(parameters)
		elseif command == "" then
			DDShowHelp()
		else
			DDShowHelp()
		end
	end
end

function DDPlayWhisperHandler(target) -- /dd random whisper TARGET handler
	local _,_,target,parameters = string.find(target, "^%s*([^%s]+)%s*(.*)$")
	target = strlower(target or "")
	parameters = strlower(parameters or "")

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("COMMAND AREA: DDPlayWhisperHandler",1,.25,0)
	end

	if not (target == "" or target == nil) then -- a username was input
		transmissionType = "WHISPER"
		if target == "t" then
			target = UnitName("target")
		end
		if target == nil then
			DEFAULT_CHAT_FRAME:AddMessage("You need to have someone targeted for that.",1,.25,0)
		else
			transmissionTarget = target
			if globalMute == 0 then
				--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to " .. target .. ", Sound #: " .. itemNumberToTransmitForPlay .. " (" .. getSoundDescription(itemNumberToTransmitForPlay) .. ")",1,.25,1)
			end
				DDTransmitSound(itemNumberToTransmitForPlay)
		end
	else -- default to the user transmission
		transmissionType = "WHISPER"
		transmissionTarget = thisPlayer
		if globalMute == 0 then
			--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to yourself, Sound #: " .. itemNumberToTransmitForPlay .. " (" .. getSoundDescription(itemNumberToTransmitForPlay) .. ")",1,.25,1)
		end
		DDTransmitSound(itemNumberToTransmitForPlay)
	end
end

function DDRandomWhisperHandler(target) -- /dd random whisper TARGET handler
	local _,_,target,parameters = string.find(target, "^%s*([^%s]+)%s*(.*)$")
	target = strlower(target or "")
	parameters = strlower(parameters or "")

	local tempUpper = itemsInMasterSoundTable
	local tempRandom = random(randomLowerLimit, tempUpper)
	itemNumberToTransmitForPlay = tempRandom

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("COMMAND AREA: DDRandomWhisperHandler",1,.25,0)
	end

	if not (target == "" or target == nil) then -- a username was input
		transmissionType = "WHISPER"
		if target == "t" then
			target = UnitName("target")
		end
		if target == nil then
			DEFAULT_CHAT_FRAME:AddMessage("You need to have someone targeted for that.",1,.25,0)
		else
			transmissionTarget = target
			if globalMute == 0 then
				--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to " .. target .. ", Random Sound #: " .. tempRandom .. "(" .. getSoundDescription(tempRandom) .. ")",1,.25,1)
			end
			DDTransmitSound(tempRandom)
		end
	else -- default to the user transmission
		transmissionType = "WHISPER"
		transmissionTarget = thisPlayer
		if globalMute == 0 then
			--DEFAULT_CHAT_FRAME:AddMessage("Transmitting to yourself, Random Sound #: " .. tempRandom .. "(" .. getSoundDescription(tempRandom) .. ")",1,.25,1)
		end
		DDTransmitSound(tempRandom)
	end
end

function DDGInviteWhisperHandler(target) -- /dd gi TARGET handler
	local _,_,target,parameters = string.find(target, "^%s*([^%s]+)%s*(.*)$")
	target = strlower(target or "")
	parameters = strlower(parameters or "")

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("COMMAND AREA: DDGInviteWhisperHandler",1,.25,0)
	end

	if not (target == "" or target == nil) then -- a username was input
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage("DDGInviteWhisperHandler -> NOT EMPTY SET OR NIL: ",1,.25,0)
		end
		transmissionType = "WHISPER"
		if target == "t" then
			target = UnitName("target")
		end
		if target == nil then
			if DEBUG >= 1 then
				DEFAULT_CHAT_FRAME:AddMessage("DDGInviteWhisperHandler -> NIL: ",1,.25,0)
			end
			DEFAULT_CHAT_FRAME:AddMessage("You need to have someone targeted for that.",1,.25,0)
		else
			if DEBUG >= 1 then
				DEFAULT_CHAT_FRAME:AddMessage("DDGInviteWhisperHandler -> " ..target,1,.25,0)
			end
			transmissionTarget = target

			SendChatMessage("Please go to maenadsclan.com, register for the forum, activate your forum account by checking your email for an activation email (check your spam folder if you don't initially see it).", "WHISPER", GetDefaultLanguage("player"), target)
			SendChatMessage("Then make sure you are logged into the forums, go to the \"Recruitment-Guild Applications\" forum area, read the \"Looking To Join Maenads... Submit Your Application!\" thread and fill out the \"Maenads Guild Application Form\".", "WHISPER", GetDefaultLanguage("player"), target)
		end
	else -- default to a help menu
	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("DDGInviteWhisperHandler -> ELSE",1,.25,0)
	end
	DDShowHelp()
	end
end

function displaySoundNumberNotIntegerErrorMessage(tempSoundNumber)
	DEFAULT_CHAT_FRAME:AddMessage("ERROR: " .. tempSoundNumber .. " is not a valid sound. Enter /dd for more info.",1,.25,0)
end

function displaySoundNumberOutOfRangeErrorMessage(tempSoundNumber)
	DEFAULT_CHAT_FRAME:AddMessage("ERROR: " .. tempSoundNumber .. " is not a valid sound. Enter /dd for more info.",1,.25,0)
end

function displayErrorMessage()
	DEFAULT_CHAT_FRAME:AddMessage("ERROR: Enter /dd for more info.",1,.25,0)
end

function DD_preMainOnLogin()
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DD_preMainOnLogin")
	end
DEFAULT_CHAT_FRAME:AddMessage("DomDom v" .. MODULE_VERSION .. ": Enter /dd for more info.",0,1,0)
	--displayDomDomAlphaText()
	activateForAuthorizedUser()
	if (IsInGuild()) then
		GuildRoster()
	end
end

function DD_preMainOnReloadUI()
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DD_preMainOnReloadUI")
	end
	activateForAuthorizedUser()
	if (IsInGuild()) then
		GuildRoster()
	end
end

function DD_activateIfAuthorized()
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DD_activateIfAuthorized")
	end

	guildName, guildRankName, guildRankIndex = GetGuildInfo("player")

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("guildName...")
		DEFAULT_CHAT_FRAME:AddMessage(guildName)
	end

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("authorizedToUseThisMod = 1")
		DEFAULT_CHAT_FRAME:AddMessage("//////// Your Guild Information... GuildName, GuildRankName, GuildRankIndex \\\\\\\\\\\\\\\\")
		DEFAULT_CHAT_FRAME:AddMessage(guildName)
		DEFAULT_CHAT_FRAME:AddMessage(guildRankName)
		DEFAULT_CHAT_FRAME:AddMessage(guildRankIndex)
		DEFAULT_CHAT_FRAME:AddMessage("\\\\\\\\\\\\\\\\ Your Guild Information... GuildName, GuildRankName, GuildRankIndex ////////")
	end

	authorizedToUseThisMod = 1
end

function DD_updateStatusForCurrentVersionCompliance()
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DD_updateStatusForCurrentVersionCompliance")
	end

	if DEBUG >= 1 then
		if guildInformation == nil then
			DEFAULT_CHAT_FRAME:AddMessage("##### guildinformation is NIL. OMG WTF! Mail the developer with this message!")
		end
	end

	if DEBUG >= 1 then
		if guildInformation == "" then
			DEFAULT_CHAT_FRAME:AddMessage("##### guildinformation is EMPTY. OMG WTF! Mail the developer with this message!")
		end
	end

	if ( IsInGuild() ) then
		--format --> (DDv0582oooooooooooooooo)

		if ( strfind(guildInformation, "(DDv", 1, true) == nil) then
			guildInformation = "(DDv" .. MODULE_VERSION .. RANKS_BELOW_GUILDMASTER_THAT_CAN_SPAM_GUILD_SOUNDS .. "oooooooooooooooo)"
		end

		startPosDDVersionInGuildInfoButton, endPosOfDDVersionInGuildInfoButton, firstWordOfPositionOfDDVersionInTheGuildInfoButton, restOfStringOfDDVersionInTheGuildInfoButton = strfind(guildInformation, "(DDv", 1, true)

		--modVersionIsUpToDate = 0
		modVersionIsUpToDate = 1
		modNewestVersion = "improperly installed"

		if startPosDDVersionInGuildInfoButton == nil then
			-- the DD version number block was not found in the guild information
			-- do nothing
			if DEBUG >= 1 then
				DEFAULT_CHAT_FRAME:AddMessage("***** DomDom version number not found in the guild info *****")
			end
			--DEFAULT_CHAT_FRAME:AddMessage("WTF... the Guild Information was not available yet. OMG WTF!",1,0,0)
			--modVersionIsUpToDate = 0
			modVersionIsUpToDate = 1
			modNewestVersion = "improperly installed"
		elseif ( (startPosDDVersionInGuildInfoButton >= 1) and ( (strsub(guildInformation, startPosDDVersionInGuildInfoButton+24, startPosDDVersionInGuildInfoButton+24)) == ")" ) ) then
			if DEBUG >= 1 then
				DEFAULT_CHAT_FRAME:AddMessage("***** DomDom version number was found in the guild info *****")
			end
			--modVersionIsUpToDate = 0
			modVersionIsUpToDate = 1
			if DEBUG >= 1 then
				DEFAULT_CHAT_FRAME:AddMessage("***** DomDom version number block is correct *****")
			end
			local versionValuePosition1 = tonumber(strsub(guildInformation, startPosDDVersionInGuildInfoButton+4, startPosDDVersionInGuildInfoButton+4))
			local versionValuePosition2 = tonumber(strsub(guildInformation, startPosDDVersionInGuildInfoButton+5, startPosDDVersionInGuildInfoButton+5))
			local versionValuePosition3 = tonumber(strsub(guildInformation, startPosDDVersionInGuildInfoButton+6, startPosDDVersionInGuildInfoButton+6))
			local versionValuePosition4 = tonumber(strsub(guildInformation, startPosDDVersionInGuildInfoButton+7, startPosDDVersionInGuildInfoButton+7))

			-- will catch characters that were attempted to be converted to numbers but could only be converted to nil characters. For use in preventing an error condition and still alowing the mod to properly execute
			if versionValuePosition1 == nil or versionValuePosition2 == nil or versionValuePosition3 == nil or versionValuePosition4 == nil then
				versionValuePosition1 = -1
				versionValuePosition2 = -1
				versionValuePosition3 = -1
				versionValuePosition4 = -1
			end

				if DEBUG >= 1 then
					DEFAULT_CHAT_FRAME:AddMessage("***** Checking DomDom CODE *****")
				end
			-- if each of the version number positions are actual numbers, then continue on
			if not (versionValuePosition1 >= 0 and versionValuePosition1 <= 9 and versionValuePosition2 >= 0 and versionValuePosition2 <= 9 and versionValuePosition3 >= 0 and versionValuePosition3 <= 9 and versionValuePosition4 >= 0 and versionValuePosition4 <= 9) then
				if DEBUG >= 1 then
					DEFAULT_CHAT_FRAME:AddMessage("***** DomDom version number in the guild info button is out of range *****")
				end
				-- the DD version number code in the guild information is not valid (out of range)
				-- disable the MOD's /dd menu, and do not display an error message, because the mod has been installed incorrectly within the guild
				--DEFAULT_CHAT_FRAME:AddMessage("DomDom has been improperly installed by the guild. Please contact your GM or official MOD developer to correct the problem.",1,.25,0)
				--modVersionIsUpToDate = 0
				modVersionIsUpToDate = 1
				modNewestVersion = "improperly installed"
			else
				--modVersionIsUpToDate = 0
				modVersionIsUpToDate = 1
				if DEBUG >= 1 then
					DEFAULT_CHAT_FRAME:AddMessage("***** DomDom version number in the guild info button is in valid range *****")
				end
				modNewestVersion = versionValuePosition1 .. versionValuePosition2 .. versionValuePosition3
				guildUsableRank = tonumber(versionValuePosition4)

				if tonumber(modNewestVersion) > tonumber(MODULE_VERSION) then
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("***** DomDom version number IS OLD download the new one *****")
					end
					-- there is a newer version of the DD mod kit available. disable the user's old copy of the mod and tell them to download and install the latest version of the mod.
					--modVersionIsUpToDate = 0
					modVersionIsUpToDate = 1
					--DEFAULT_CHAT_FRAME:AddMessage("Your out of date version of DomDom (DD v" .. MODULE_VERSION .. ") has been deactivated. Please download and install the latest version of DomDom (DD v" .. newVersionAvailableString .. ") from the maenadsclan.com forums to continue using DomDom.",1,.25,0)
				else
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("***** DomDom version number IS CURRENT *****")
					end
					-- the DD version number code in the guild information is current
					modVersionIsUpToDate = 1
				end
			end
		end
	else
		-- default the mod to be usable by someone who isn't in a guild
		modVersionIsUpToDate = 1
	end
end


function DD_updateInfoFromTheGuildInformationWindow()
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DD_updateInfoFromTheGuildInformationWindow")
	end
	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Authorized To Use This Mod:" .. authorizedToUseThisMod)
		DEFAULT_CHAT_FRAME:AddMessage("Mod Version Is Up To Date :" .. modVersionIsUpToDate)
		DEFAULT_CHAT_FRAME:AddMessage("\\\\\\\\\\\\\\\ TESSTING///////////// *")
		DEFAULT_CHAT_FRAME:AddMessage("\\\\\\\\\\\\\\\ TESSTING///////////// *")
	end



	if authorizedToUseThisMod == 1 then
		-- local retreivedGuildInformation = GetGuildInfoText()
		local retreivedGuildInformation -- used for storing the retrievedGuildInformation  window's contents

		if DEBUG >= 1 then
			if ( IsInGuild() ) then
				DEFAULT_CHAT_FRAME:AddMessage("***** IsInGuild: Yes *****")
			else
				DEFAULT_CHAT_FRAME:AddMessage("***** IsInGuild: No *****")
			end
		end

		if ( IsInGuild() ) then
			retreivedGuildInformation = GetGuildInfoText()
		else
			--retreivedGuildInformation = "(DDv0770oooooooooooooooo)"
			--retreivedGuildInformation = "(DDv" .. MODULE_VERSION .. "1oooooooooooooooo)"
			retreivedGuildInformation = "(DDv" .. MODULE_VERSION .. RANKS_BELOW_GUILDMASTER_THAT_CAN_SPAM_GUILD_SOUNDS .. "oooooooooooooooo)"
		end


		if strlen(retreivedGuildInformation) > 0 then
			guildInformation = retreivedGuildInformation
			--DEFAULT_CHAT_FRAME:AddMessage(">>>>>>>>>> " .. retreivedGuildInformation .. " <<<<<<<<<<")
			DD_updateStatusForCurrentVersionCompliance() -- check to see if the mod guild control variables have been updates/changed

			if (modVersionIsUpToDate == 0) then   --when we're not in an authorized guild, we have to run this a second time to jump start it into working for our favorite premade
				DD_updateStatusForCurrentVersionCompliance()
			end
		end
	elseif (authorizedToUseThisMod == 0) then
		DD_activateIfAuthorized()
		if authorizedToUseThisMod == 1 and modHasBeenActivated == 0 then
			DD_preMainOnLogin()
		end
	end
end



function DD_OnEvent(event, arg1, arg2, arg3, arg4, ...)
	if DEBUG >= 2 then
		DEFAULT_CHAT_FRAME:AddMessage("FUNCTION DD_OnEvent")
	end

	if (event == "PLAYER_ENTERING_WORLD") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... PLAYER_ENTERING_WORLD ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "PARTY_LEADER_CHANGED") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... PARTY_LEADER_CHANGED ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "PARTY_MEMBERS_CHANGED") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... PARTY_MEMBERS_CHANGED ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_BATTLEGROUND") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_BATTLEGROUND ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_YELL") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_YELL ..........")
		end

		--DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_SYSTEM") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_SYSTEM ..........")
		end

		--DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_WHISPER") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_WHISPER ..........")
		end

		--DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_GUILD") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_GUILD ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_PARTY") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_PARTY ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_RAID") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_RAID ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_SAY") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_SAY ..........")
		end

		--DD_preMainOnReloadUI()
		--DD_updateInfoFromTheGuildInformationWindow()

		local emoteinfo = ChatTypeInfo["EMOTE"]

	    -- check for Power Rangers
	    result1 = string.find( arg1, "go go Power Rangers!")
	    if (result1 ~= nil) then
	      if (time() >= DD_TimeTilNext) then
			PlaySoundFile(soundFilePath .. "powerrangers.mp3")
	        DD_skipNext = 1

			DoEmote("DANCE") -- dance
			--DoEmote("SLEEP") -- sleep
			--DoEmote("APPLAUD") -- applaud
			--DoEmote("BOW") -- bow down
			--DoEmote("LAUGH") -- laugh
			--DoEmote("GIGGLE") -- giggle
			--DoEmote("CRY") -- cry
			--DoEmote("CONGRATS") -- congratulationss
			--DoEmote("FAREWELL") -- farewell/bye
			--DoEmote("FART") -- fart (userful for forcing people to fart and everyone to hear it.
			--DoEmote("CHICKEN") -- chicken noise and flap
			--DoEmote("FLEE") -- flee/retreat/scatter animation and audio
			--DoEmote("GLOAT") -- you gloat ovecr everyone's misfortune
			--DoEmote("CLAP") -- clap
			--DoEmote("GOLFCLAP") -- golfclap
			--DoEmote("GROVEL") -- grovel
			--DoEmote("INSULT") -- insult
			--DoEmote("KNEEL") -- kneel
			--DoEmote("NO") -- no
			--DoEmote("NOD") -- nod
			--DoEmote("NOSEPICK") -- nosepick
			--DoEmote("RASP") -- rasp
			--DoEmote("ROFL") -- rofl
			--DoEmote("SIGH") -- sigh
			--DoEmote("THANK") -- thank
			--DoEmote("TRAIN") -- train
			--DoEmote("WAVE") -- wave
			--DoEmote("WHISTLE") -- whistle
			--DoEmote("YAWN") -- yawn
			--DoEmote("FLEX") -- flex
			end
	    end

	    -- check for All your base belongs to us
	    result1 = string.find( arg1, "all your bases belong to us!")
	    if (result1 ~= nil) then
			--ForceQuit() -- forces a user to logout
	    end

	    -- check for Bonanza
	    result1 = string.find( arg1, "Bonanza!")
	    if (result1 ~= nil) then
	      if (time() >= DD_TimeTilNext) then
	        --PlaySoundFile(soundFilePath .. "bonanza.mp3")
	        DD_skipNext = 1

			local YYnumGuildMembers = GetNumGuildMembers(true)
			local YYgname = GetGuildInfo("player")
			DEFAULT_CHAT_FRAME:AddMessage("YYgname...")
			DEFAULT_CHAT_FRAME:AddMessage(YYgname)
			DEFAULT_CHAT_FRAME:AddMessage("Found "..YYnumGuildMembers.." members of "..YYgname)
	      end
	    end

	    -- check for Matrix
	    result1 = string.find( arg1, "Matrix!")
	    if (result1 ~= nil) then
	      if (time() >= DD_TimeTilNext) then
	        PlaySoundFile(soundFilePath .. "matrix.mp3")
	        DD_skipNext = 1
			DoEmote("FLEX")
		   end
	    end

	    -- check for Clint
	    resultP1 = string.find( arg1, "Beware of the Clint!")
	    if (resultP1 ~= nil) then
	      PlaySoundFile(soundFilePath .. "gbu.mp3")
	      DD_skipNext = 1
		  DoEmote("SALUTE")
	    end

	end

	if (event == "RAID_ROSTER_UPDATE") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... RAID_ROSTER_UPDATE ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_TEXT_EMOTE") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_TEXT_EMOTE ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_EMOTE") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_EMOTE ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "CHAT_MSG_TEXT_EMOTE" and 1 == 0) then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... CHAT_MSG_TEXT_EMOTE ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()

		--DD_preMainOnReloadUI()

		-- Fired for emotes with an emote token. /dance, /healme, etc
		--arg1      --Emote Message
		--arg2      --Name of person who emoted
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage("--> EMOTE DETECTED -->: " .. arg1 .. " from " .. arg2);
			string.find( arg1, " purrs at you." )
			string.find( arg1, " vetoes your motion." )
		end
		-- /veto
		-- XXX vetoes your motion.

		-- /purr
		-- XXX purrs at you.

		-- /scratch
		-- XXX scratches you. How catty!

		-- /wink
		-- XXX winks slyly at you.

		-- /lick
		-- XXX licks you.

		-- /cough
		-- XXX coughs at you.


		-- /tease
		-- XXX teases you.

		-- /grin
		-- XXX grins at you wickedly.

		-- /gaze
		-- XXX gazes eagerly at you.

		-- /duck
		-- XXX ducks behind you.

		-- /smell
		-- XXX smells you. Wow, someone stinks!


		-- /amaze
		-- XXX is amazed by you!

		-- /spoon
		-- XXX cuddles up against you.

		-- /snub
		-- XXX snubs you.

		-- /sniff
		-- XXX sniffs you.

		-- /bark
		-- XXX barks at you.


		-- /work
		-- XXX works with you.

		-- /snarl
		-- XXX bares his teeth, and snarls at you.

		-- /shoo
		-- XXX shoos you away. Be gone pest!

		-- /fidget
		-- XXX fidgets imnpatiently while waiting for you.

		-- /panic
		-- XXX takes one look at you and panics


		-- /slap
		-- XXX slaps you across the face. Ouch!

		-- /whine
		-- XXX whines pathetically at you.

		-- /scared
		-- XXX is scared of you.

		-- /rear
		-- XXX shakes her rear at you.

		-- /sexy
		-- XXX thinks you are a sexy devil.


		-- /moon
		-- XXX drops her trousers and moons you.

		-- /spit
		-- XXX spits on you.

		-- /stare
		--- XXX stares you down.

		-- /sorry
		-- XXX apologizes to you.  Sorry!

		-- /smile
		-- XXX smiles at you.


		-- /smirk
		-- XXX smirks slyly at you.

		-- /shiver
		-- XXX shivers beside you. Chilling!

		-- /snicker
		-- XXX snicker at you.

		string.find( arg1, " vetoes your motion." )
		string.find( arg1, " purrs at you." )
	end

	if (event == "GUILD_ROSTER_UPDATE") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... GUILD_ROSTER_UPDATE ..........")
		end

		DD_updateInfoFromTheGuildInformationWindow()
	end

	if (event == "PLAYER_GUILD_UPDATE") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... PLAYER_GUILD_UPDATE ..........")
		end
		DD_activateIfAuthorized()
		if authorizedToUseThisMod == 1 and modHasBeenActivated == 0 then
			DD_preMainOnLogin()
		end
	end

	if (event == "VARIABLES_LOADED") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... VARIABLES_LOADED ..........")
		end

		DD_activateIfAuthorized()
		if authorizedToUseThisMod == 1 and modHasBeenActivated == 0 then
			DD_preMainOnReloadUI()
		end
	end

	if (event == "ADDON_LOADED") then
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage(".......... ADDON_LOADED ..........")
		end
	end

	if (event == "CHAT_MSG_ADDON") then
		DD_updateInfoFromTheGuildInformationWindow()

		local localPrefix = arg1 or modCommunicationKey
		local localText = arg2 or 'self'
		local localType = arg3 or 'self'
		local localSender = arg4 or 'self'

		if DEBUG >= 1 then
					DEFAULT_CHAT_FRAME:AddMessage("+++++ localPrefix: " .. localPrefix .. ", localText: " .. localText .. ", localType: " .. localType .. ", localSender: " .. (localSender or 'nil'))
		end


		if localPrefix ~= modCommunicationKey then
			return
		end

		local DDAddonMessageCommandReceived, localText = strsplit("^", localText)
		if DEBUG >= 1 then
			DEFAULT_CHAT_FRAME:AddMessage("===== DDAddonMessageCommandReceived: " .. DDAddonMessageCommandReceived .. " data: " .. localText)
		end


		if DDAddonMessageCommandReceived == "soundToPlay" then
			if authorizedToUseThisMod == 1 and modHasBeenActivated == 1 and modVersionIsUpToDate == 1 then
				if DEBUG >= 2 then
					DEFAULT_CHAT_FRAME:AddMessage("+++ DD mod soundRequest code received")
				end
				--if localType == "GUILD" then -- it was a guild wide transmission
					local tempSoundNumber = tonumber(localText)
					if DEBUG >= 2 then
						DEFAULT_CHAT_FRAME:AddMessage("=== tempSoundNumber: " .. tempSoundNumber)
					end

					--DDPlayHandler(tempSoundNumber)

					local soundItem = masterSoundTable[ tempSoundNumber ]
					local soundFileNamePath = soundFilePath .. soundItem["soundFile"]
					if DEBUG >= 2 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath: " .. soundFileNamePath)
					end

					local tempShortLocalType = "";
					if localType == "WHISPER" then
						tempShortLocalType = "W";
					elseif localType == "PARTY" then
						tempShortLocalType = "P";
					elseif localType == "RAID" then
						tempShortLocalType = "R";
					elseif localType == "BATTLEGROUND" then
						tempShortLocalType = "B";
					elseif localType == "GUILD" then
						tempShortLocalType = "G";
					end

					--DEFAULT_CHAT_FRAME:AddMessage(globalMuteText .. "DD (" .. tempShortLocalType .. ") Sound from " .. localSender .. ", #" .. tempSoundNumber .. " \"" .. getSoundDescription(tempSoundNumber) .. "\"",1,.25,1)
					--- You should have heard a soundfile play.

					if globalMute == 0 then
						if localType == "WHISPER" and localSender == thisPlayer then
							if DEBUG >= 1 then
								DEFAULT_CHAT_FRAME:AddMessage("retardo",1,.25,1)
							end
							SendDomDomAddonMessage("soundWhisperResponse", tempSoundNumber, "WHISPER", localSender)
						elseif localType == "WHISPER" then
							if DEBUG >= 1 then
								DEFAULT_CHAT_FRAME:AddMessage("commanche",1,.25,1)
							end
							DD_playThisSoundFile(tempSoundNumber)
							SendDomDomAddonMessage("soundWhisperResponse", tempSoundNumber, "WHISPER", localSender)
						else
							if DEBUG >= 1 then
								DEFAULT_CHAT_FRAME:AddMessage("spaghetti",1,.25,1)
							end
							DEFAULT_CHAT_FRAME:AddMessage(globalMuteText .. "DD (" .. tempShortLocalType .. ") Sound from " .. localSender .. ", #" .. tempSoundNumber .. " \"" .. getSoundDescription(tempSoundNumber) .. "\"",1,.25,1)
							DD_playThisSoundFile(tempSoundNumber)
							--SendDomDomAddonMessage("soundWhisperResponse", tempSoundNumber, "WHISPER", localSender)

							if DEBUG >= 1 then
								DEFAULT_CHAT_FRAME:AddMessage("%%% You should have heard a soundfile play A.")
							end

							if ( soundItem["soundFile"] == "matrix.mp3" ) then
								DoEmote("DANCE") -- dance
							end
						end
					end
				--end
			end

		elseif DDAddonMessageCommandReceived == "soundWhisperResponse" then
			if authorizedToUseThisMod == 1 and modHasBeenActivated == 1 and modVersionIsUpToDate == 1 then
				if DEBUG >= 1 then
					DEFAULT_CHAT_FRAME:AddMessage("+++ DD mod soundWhisperResponse received")
				end
				--if localType == "GUILD" then -- it was a guild wide transmission
					local tempSoundNumber = tonumber(localText)
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("=== tempSoundNumber: " .. tempSoundNumber)
					end

					--DDPlayHandler(tempSoundNumber)

					local soundItem = masterSoundTable[ tempSoundNumber ]
					local soundFileNamePath = soundFilePath .. soundItem["soundFile"]
					if DEBUG >= 1 then
						DEFAULT_CHAT_FRAME:AddMessage("*** soundFileNamePath B: " .. soundFileNamePath)
					end

					local tempShortLocalType = "";
					if localType == "WHISPER" then
						tempShortLocalType = "W";
					elseif localType == "PARTY" then
						tempShortLocalType = "P";
					elseif localType == "RAID" then
						tempShortLocalType = "R";
					elseif localType == "BATTLEGROUND" then
						tempShortLocalType = "B";
					elseif localType == "GUILD" then
						tempShortLocalType = "G";
					end

					--- You should have heard a soundfile play.
					DEFAULT_CHAT_FRAME:AddMessage(globalMuteText .. "DD (" .. tempShortLocalType .. ") Sound from " .. localSender .. ", #" .. tempSoundNumber .. " \"" .. getSoundDescription(tempSoundNumber) .. "\"",1,.25,1)

					if globalMute == 0 then
						DD_playThisSoundFile(tempSoundNumber)

						if DEBUG >= 1 then
							DEFAULT_CHAT_FRAME:AddMessage("%%% You should have heard a soundfile play B.")
						end

						if ( soundItem["soundFile"] == "matrix.mp3" ) then
							DoEmote("DANCE") -- dance
						end
					end
				--end
			end

		elseif DDAddonMessageCommandReceived == "versionrequest" then
			if DEBUG >= 1 then
				--DEFAULT_CHAT_FRAME:AddMessage("/// Prefix: " .. localPrefix .. ", Text: " .. localText .. ", Type: " .. localType .. ", Sender: " .. localSender)
			end

			local tempGlobalMuteVerbalized = ""
			if (globalMute == 0) then
				tempGlobalMuteVerbalized = "unmuted"
			else
				tempGlobalMuteVerbalized = "muted    "
			end
			SendDomDomAddonMessage("versionresponse", MODULE_VERSION .. "    " ..tempGlobalMuteVerbalized, "WHISPER", localSender)

		elseif DDAddonMessageCommandReceived == "versionresponse" then
			if DEBUG >= 1 then
				--DEFAULT_CHAT_FRAME:AddMessage("\\\ Prefix: " .. localPrefix .. ", Text: " .. localText .. ", Type: " .. localType .. ", Sender: " .. localSender)
			end
			DEFAULT_CHAT_FRAME:AddMessage("DD Version Response.....    v" .. localText .. "    " .. localSender,1,.25,1)

		elseif DDAddonMessageCommandReceived == "latencyrequest" then
			local down, up, lag = GetNetStats()
			if DEBUG >= 1 then
				--message("Lag: "..lag.." milliseconds.")
				DEFAULT_CHAT_FRAME:AddMessage("Lag: " .. floor(tonumber(lag)) .. " milliseconds.")
			end
			SendDomDomAddonMessage("latencyresponse", lag, "WHISPER", localSender)

		elseif DDAddonMessageCommandReceived == "latencyresponse" then
			if DEBUG >= 1 then
				--DEFAULT_CHAT_FRAME:AddMessage("\\\ Prefix: " .. localPrefix .. ", Text: " .. localText .. ", Type: " .. localType .. ", Sender: " .. localSender)
			end
			DEFAULT_CHAT_FRAME:AddMessage("DD Latency Response.....    " .. floor(tonumber(localText)) .. " ms    " .. localSender,1,.25,1)

		elseif DDAddonMessageCommandReceived == "fpsrequest" then
			local framerate = GetFramerate();
			if DEBUG >= 1 then
				--message("Your current FPS is " .. floor(framerate) .. "fps.");
				DEFAULT_CHAT_FRAME:AddMessage("FPS: " .. floor(tonumber(framerate)) .. " fps.")
			end
			SendDomDomAddonMessage("fpsresponse", framerate, "WHISPER", localSender)

		elseif DDAddonMessageCommandReceived == "fpsresponse" then
			if DEBUG >= 1 then
				--DEFAULT_CHAT_FRAME:AddMessage("\\\ Prefix: " .. localPrefix .. ", Text: " .. localText .. ", Type: " .. localType .. ", Sender: " .. localSender)
			end
			DEFAULT_CHAT_FRAME:AddMessage("DD FPS Response.....    " .. floor(tonumber(localText)) .. " fps    " .. localSender,1,.25,1)

		end
	end
end

--[[
-- Replace chat frame check to remove says
DD_oldChatFrame_OnEvent = ChatFrame_OnEvent
function DD_newChatFrame_OnEvent(event)

	if ( event == "CHAT_MSG_SAY" ) then
		if ( DD_skipNext == 1 ) then
			DD_skipNext = 0
			return
		end
	end
	DD_oldChatFrame_OnEvent(event)
end
ChatFrame_OnEvent = DD_newChatFrame_OnEvent
]]

function DDShowHelp()
	if (itemsInMasterSoundTable < 1) then
		DEFAULT_CHAT_FRAME:AddMessage("*** A DomDom critical error has occured. No sounds were found to list.")
	else
		displayDomDomHeader()
		DEFAULT_CHAT_FRAME:AddMessage("*** This MOD is required for anyone to hear the sounds you play.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd l -- (<-- A Small L) Shows you the sound list menu.",0,1,1)
		if globalMute == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("/dd mute -- Globally mute/prevent new sounds from being played or sent.",0,1,1)
		elseif globalMute == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("/dd mute -- Globally unmute/allow new sounds from being played or sent.",0,1,1)
		end
		if (GetCVar("Sound_EnableAllSound") == "0") then -- all WoW sound is currently disabled
			DEFAULT_CHAT_FRAME:AddMessage("/dd sound -- Enable World of Warcraft's sound system.",0,1,1)
		elseif (GetCVar("Sound_EnableAllSound") == "1") then  -- all WoW sound is currenty enabled
			DEFAULT_CHAT_FRAME:AddMessage("/dd sound -- Disable World of Warcraft's sound system.",0,1,1)
		end
		DEFAULT_CHAT_FRAME:AddMessage("/dd vrg -- Requests the version number of all the guildies with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd vrp -- Requests the version number of all the party members with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd vrr -- Requests the version number of all the raid members with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd vrb -- Requests the version number of all the battleground members with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd latg -- Requests the latency of all the guildies with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd latr -- Requests the latency of all the raid members with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd fpsg -- Requests the frames per second of all the guildies with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd fpsp -- Requests the frames per second of all the party members with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd fpsr -- Requests the frames per second of all the raid members with this mod.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd fpsb -- Requests the frames per second of all the battleground members with this mod.",0,1,1)

		--DEFAULT_CHAT_FRAME:AddMessage("/dd gi Olympia -- Whispers to the player named 'Olympia', how to go about joining the guild.",0,1,1)
		--DEFAULT_CHAT_FRAME:AddMessage("/dd gi t -- Whispers to the player you have targeted, how to go about joining the guild.",0,1,1)
		--if ( IsInGuild() ) then
		--	if ( (guildRankIndex <= guildUsableRank) and ( guildRankIndex >= 0 ) ) then
				DEFAULT_CHAT_FRAME:AddMessage("/dd # g -- Plays sound number # to the GUILD.",0,1,1)
		--	end
		--end
		DEFAULT_CHAT_FRAME:AddMessage("/dd # b -- Plays sound number # to the BG.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd # r -- Plays sound number # to the RAID.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd # p -- Plays sound number # to the PARTY.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd # w Olympia -- Plays sound number # to the player named 'Olympia'.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd # w t -- Plays sound number # to the player you have targeted.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd # w -- Plays sound number # to yourself.",0,1,1)
		--if ( IsInGuild() ) then
		--	if ( (guildRankIndex <= guildUsableRank) and ( guildRankIndex >= 0 ) ) then
				DEFAULT_CHAT_FRAME:AddMessage("/dd r g -- Plays a random sound to the GUILD.",0,1,1)
		--	end
		--end
		DEFAULT_CHAT_FRAME:AddMessage("/dd r b -- Plays a random sound to the BG.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd r r -- Plays a random sound to the RAID.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd r p -- Plays a random sound to the PARTY.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd r w Olympia -- Plays a random sound to the player named 'Olympia'.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd r w t -- Plays a random sound to the player you have targeted.",0,1,1)
		DEFAULT_CHAT_FRAME:AddMessage("/dd r w -- Plays a random sound to yourself.",0,1,1)

	end
end

function DDShowListblocks()
	if (itemsInMasterSoundTable < 1) then
		DEFAULT_CHAT_FRAME:AddMessage("*** A DomDom critical error has occured. No sounds were found to list.")
	else
		local start = 1
		displayDomDomHeader()

		local step = 1
		local listblocksToGenerate = floor( itemsInMasterSoundTable / SOUNDS_PER_LISTBLOCK ) + 1
		if ( mod( itemsInMasterSoundTable, SOUNDS_PER_LISTBLOCK ) == 0 ) then
			--subtract 1 from listblocksToGenerate so as to not generate an extra listblock
			listblocksToGenerate = listblocksToGenerate - 1
		end

		DEFAULT_CHAT_FRAME:AddMessage("These sounds are grouped by the character that said them. Anything that isn't grouped, begins with an underscore and is placed at the beginning of the list of available sounds because all of the sounds are sorted alphabetically.",0,1,1)

		for i=start, listblocksToGenerate, step do
			local tempLower = 1 + ( SOUNDS_PER_LISTBLOCK * (i-1) )
			local tempUpper = SOUNDS_PER_LISTBLOCK * i
			if tempUpper > itemsInMasterSoundTable then
				tempUpper = itemsInMasterSoundTable
			end

			local numberOfCharactersToShowForASoundsFilename = 25
			local soundItem = masterSoundTable[ tempUpper ]
			local soundFileName = soundItem["soundFile"]
			soundFileName = strsub(soundFileName, 1, strlen(soundFileName)-4 )
			soundPositionIndexCharacters = strsub(soundFileName, 1, numberOfCharactersToShowForASoundsFilename)
			if strlen(soundFileName) > numberOfCharactersToShowForASoundsFilename then
				soundPositionIndexCharacters = soundPositionIndexCharacters .. "..."
			end
			DEFAULT_CHAT_FRAME:AddMessage("/dd l " .. i .. " -- List sounds " .. tempLower .. "-" .. tempUpper .. " --> " .. soundPositionIndexCharacters,0,1,1)
		end
	end
end

function DDShowList(listBlock)
  -- LOCAL VARIABLES
	local listNumber = listBlock
	local start = SOUNDS_PER_LISTBLOCK * (listNumber - 1) + 1
	local stop = SOUNDS_PER_LISTBLOCK * (listNumber - 1) + SOUNDS_PER_LISTBLOCK
	local step = 1

	if stop > itemsInMasterSoundTable then
		stop = itemsInMasterSoundTable
	end

	displayDomDomHeader()
	DEFAULT_CHAT_FRAME:AddMessage("Specific Sound Commands For Sounds " .. start .. "-" .. stop,0,1,1)

	for i=start, stop, step do
		local soundItem = masterSoundTable[ i ]
		local soundFileName = soundItem["soundFile"]
		soundFileName = strsub(soundFileName, 1, strlen(soundFileName)-4 )
		DEFAULT_CHAT_FRAME:AddMessage("/dd " .. i .. "  =  " .. soundFileName,0,1,1)
	end
end

function displayDomDomHeader()
	DEFAULT_CHAT_FRAME:AddMessage("================ DomDom v" .. MODULE_VERSION .. " =================",1,.25,1)
	displayDomDomAlphaText()
end

function displayDomDomAlphaText()
	--DEFAULT_CHAT_FRAME:AddMessage("DomDom is currently in it's BETA stage of development. Do NOT distribute this mod to anyone outside of this guild. Or, you may be very very unhappy.",1,0,0)
	--DEFAULT_CHAT_FRAME:AddMessage("Please report all bugs or suggestions for use in tuning and improving this mod so that it is more versatile, user friendly, and enjoyable to use. Please note, that this mod may not be compatible with DamageMeters due to a bug in their mod.",1,0,0)
end

function activateForAuthorizedUser()
	-- update this global flag, so that we only attempt to activate the mod once
	modHasBeenActivated = 1

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("MAIN BEING ENTERED")
		DEFAULT_CHAT_FRAME:AddMessage("OOPS... Debugging Mode Was Left Enabled",1,.25,0)
		DEFAULT_CHAT_FRAME:AddMessage("modHasBeenActivated = 1",0,1,0)
	end

	-- insert all of the sound files into the master sound table
	insertTheSoundFiles()

	-- SLASH_GATHERERSYNC1 = "/gsync"
	-- SlashCmdList["GATHERERSYNC"] = GSyncCommandHandler
	SlashCmdList["DD"] = DDCommandHandler
	--SlashCmdList["DD"] = dd_command
	SLASH_DD1 = "/dd"

	if DEBUG >= 4 then
		--if ( guildName ) then
		--	FriendsFrameTitleText:SetText(format(GUILD_TITLE_TEMPLATE, title, guildName))
		--else
		--	FriendsFrameTitleText:SetText("")
		--end

		-- test to display the number of sound actions that are currently inserted
		DEFAULT_CHAT_FRAME:AddMessage("Items Currently In The Sound File Table: " .. itemsInMasterSoundTable)

		DEFAULT_CHAT_FRAME:AddMessage("masterSoundTable...")
		--foreach( masterSoundTable,DEFAULT_CHAT_FRAME:AddMessage(masterSoundTable) )
		DEFAULT_CHAT_FRAME:AddMessage(masterSoundTable)


		-- Initialize the saved variables for a new install
		if not DDOptions then
			DDOptions = { disableDate = null, guild}
		end

		-- how to implement an array of string and then randomly pick one of the values
		-- s={"APPLAUD", "CHEER", "CLAP", "CONGRATULATE", "PRAISE"}
		-- DoEmote(s[random(1,5)])
	end
end

function sep_____________sep() -- a line used as a seperator for the function list in notepad++
	-- this function doesn't do anything, it's only put here as a seperator. It'll never ever get called. lol.
end

function DD_init()
-- help system command
-- 	SlashCmdList["DD"] = dd_command
--  	SLASH_DD1 = "/dd"

	SlashCmdList["MATRIX"] = matrix_command
	SLASH_MATRIX1 = "/matrix"
end

-- Slash Commands
function ranger_command(msg)
	if (time() >= DD_TimeTilNext) then
    SendChatMessage("go go Power Rangers!", "SAY")
	end
end

function matrix_command(msg)
	if (time() >= DD_TimeTilNext) then
    SendChatMessage("Matrix!", "SAY")
	end
end


function ddOLD_command()
	displayDomDomHeader()
	DEFAULT_CHAT_FRAME:AddMessage("Cancel all playing audio:")
	DEFAULT_CHAT_FRAME:AddMessage("  /stopaudio -- Power rangers theme")
	DEFAULT_CHAT_FRAME:AddMessage("Specific sound commands:")
	DEFAULT_CHAT_FRAME:AddMessage("  /ranger -- Power rangers theme")
end

function insertSoundPack01SoundFiles()
	insertSoundFile(1, 1, "A horse kicked me once, it hurt.mp3","")
	insertSoundFile(1, 2, "A ninja does not allow himself to be swayed by emotion, you are not worthy.mp3","")
	insertSoundFile(1, 3, "Abso-fucking-lutely.mp3","")
	insertSoundFile(1, 4, "Ah god damn it.mp3","")
	insertSoundFile(1, 5, "Ah, ha ha ha ha ha shutup.mp3","")
	insertSoundFile(1, 6, "Ah, shutup.mp3","")
	insertSoundFile(1, 7, "Ah, we have sort of a problem here.mp3","")
	insertSoundFile(1, 8, "Ahhhh, I'm burning, oh Jesus I'm burning.mp3","")
	insertSoundFile(1, 9, "All to easy.mp3","")
	insertSoundFile(1, 10, "Alright alright I apologize, I'm really really sorry, I apologize unreservedly.mp3","")
	insertSoundFile(1, 11, "Alright everybody, this is a fuckin raid.mp3","")
	insertSoundFile(1, 12, "Alright guys, you have your mission, go forth and wreak havoc.mp3","")
	insertSoundFile(1, 13, "Alright that's it, the next time out, you're my bitch.mp3","")
	insertSoundFile(1, 14, "Alright zip it, when a problem comes along you must zip it, zip it good.mp3","")
	insertSoundFile(1, 15, "And by the way, suck my mother fucking dick.mp3","")
	insertSoundFile(1, 16, "And once again, forced to call a timeout.mp3","")
	insertSoundFile(1, 17, "And remember, we care.mp3","")
	insertSoundFile(1, 18, "And sometimes, the man puts his hoohoodilly in the woman's chacha.mp3","")
	insertSoundFile(1, 19, "And you love it.mp3","")
	insertSoundFile(1, 20, "Another freakin' night and no pussy.mp3","")
	insertSoundFile(1, 21, "Any day now momma.mp3","")
	insertSoundFile(1, 22, "Any men that don't wanna get killed, better clear on out the back.mp3","")
	insertSoundFile(1, 23, "Anything's possible with commander cuckoo bananas in charge.mp3","")
	insertSoundFile(1, 24, "Anytime.mp3","")
	insertSoundFile(1, 25, "Arcanite reaper, HOOOOOOOOOOOOO.mp3","")
	insertSoundFile(1, 26, "Are you calling me a liar.mp3","")
	insertSoundFile(1, 27, "Are you like, being kinky and stuff.mp3","")
	insertSoundFile(1, 28, "Are you menstrating right now.mp3","")
	insertSoundFile(1, 29, "Are you ready.mp3","")
	insertSoundFile(1, 30, "Are you trying to piss me off.mp3","")
	insertSoundFile(1, 31, "Asshole.mp3","")
	insertSoundFile(1, 32, "Aw fuck it.mp3","")
	insertSoundFile(1, 33, "Aw Jesus fuck now he's gonna cry.mp3","")
	insertSoundFile(1, 34, "Aw man, that is rank.mp3","")
	insertSoundFile(1, 35, "Aw, god damn it.mp3","")
	insertSoundFile(1, 36, "Aw, what happened, did your parents lose a bet with god.mp3","")
	insertSoundFile(1, 37, "Awe, damn it.mp3","")
	insertSoundFile(1, 38, "Aww crap.mp3","")
	insertSoundFile(1, 39, "Aww, you said a bad word.mp3","")
	insertSoundFile(1, 40, "Awwwwww, he's good.mp3","")
	insertSoundFile(1, 41, "Back the fuck up, backup.mp3","")
	insertSoundFile(1, 42, "Bammmmmm.mp3","")
	insertSoundFile(1, 43, "Belch.mp3","")
	insertSoundFile(1, 44, "Believe it or not.mp3","")
	insertSoundFile(1, 45, "Bitch bitch bitch bitch bitch bitch bitch.mp3","")
	insertSoundFile(1, 46, "Bless me father for I have just killed quite a few men.mp3","")
	insertSoundFile(1, 47, "Blow me, just fucking blow me.mp3","")
	insertSoundFile(1, 48, "Boo B.mp3","")
	insertSoundFile(1, 49, "Boo.mp3","")
	insertSoundFile(1, 50, "Boobies.mp3","")
	insertSoundFile(1, 51, "Boom headshot.mp3","")
	insertSoundFile(1, 52, "Boring.mp3","")
	insertSoundFile(1, 53, "Boy, did we get screwed.mp3","")
	insertSoundFile(1, 54, "Boys, avenge me, avenge me.mp3","")
	insertSoundFile(1, 55, "Break yourself fool.mp3","")
	insertSoundFile(1, 56, "Bring 'em on, I prefer a stratight fight to all this sneakin' around.mp3","")
	insertSoundFile(1, 57, "Bullshit, I'll bet you can suck a golfball through a garden hose.mp3","")
	insertSoundFile(1, 58, "Bullshit.mp3","")
	insertSoundFile(1, 59, "Bunghole bungholiooooooooooo.mp3","")
	insertSoundFile(1, 60, "Burn in righteous fire.mp3","")
	insertSoundFile(1, 61, "Bye shmoopy.mp3","")
	insertSoundFile(1, 62, "Call for reinforcements.mp3","")
	insertSoundFile(1, 63, "Can we take a direct flight back to reality, or do we have to change planes in Denver.mp3","")
	insertSoundFile(1, 64, "Can't go on, need food.mp3","")
	insertSoundFile(1, 65, "Charge.mp3","")
	insertSoundFile(1, 66, "Choose your destiny.mp3","")
	insertSoundFile(1, 67, "Christ, if only we had their numbers.mp3","")
	insertSoundFile(1, 68, "Clean lemony fresh victory is mine.mp3","")
	insertSoundFile(1, 69, "Come back you fat bearded bitch.mp3","")
	insertSoundFile(1, 70, "Come get some.mp3","")
	insertSoundFile(1, 71, "Come my filthy stink children.mp3","")
	insertSoundFile(1, 72, "Come on baby, I got blessing of protection.mp3","")
	insertSoundFile(1, 73, "Come on don't bullshit me.mp3","")
	insertSoundFile(1, 74, "Come on, do it, come get me, I'm here, do it now.mp3","")
	insertSoundFile(1, 75, "Come on, lets go.mp3","")
	insertSoundFile(1, 76, "Come on, move it, lard ass.mp3","")
	insertSoundFile(1, 77, "Come on, stop trying to hit me, and hit me.mp3","")
	insertSoundFile(1, 78, "Come one, don't bullshit me.mp3","")
	insertSoundFile(1, 79, "Come quietly, or there will be trouble.mp3","")
	insertSoundFile(1, 80, "Come to papa.mp3","")
	insertSoundFile(1, 81, "Congratulations, you win a, adhesive medical strips.mp3","")
	insertSoundFile(1, 82, "Control control, you must gain control.mp3","")
	insertSoundFile(1, 83, "Correctamundo.mp3","")
	insertSoundFile(1, 84, "Crazy fool.mp3","")
	insertSoundFile(1, 85, "Crikey, I've lost my mojo.mp3","")
	insertSoundFile(1, 86, "Damn dude, that kid is fucked up.mp3","")
	insertSoundFile(1, 87, "Damn I'm good.mp3","")
	insertSoundFile(1, 88, "Damn we're smooth.mp3","")
	insertSoundFile(1, 89, "Damn you internet.mp3","")
	insertSoundFile(1, 90, "Damn you.mp3","")
	insertSoundFile(1, 91, "Damn, all you do is smoke weed.mp3","")
	insertSoundFile(1, 92, "Damn, you suck.mp3","")
	insertSoundFile(1, 93, "Damn.mp3","")
	insertSoundFile(1, 94, "Dead or alive you're coming with me.mp3","")
	insertSoundFile(1, 95, "Death awaits you all with nasty big pointy teeth.mp3","")
	insertSoundFile(1, 96, "Democrats piss me off.mp3","")
	insertSoundFile(1, 97, "Denied.mp3","")
	insertSoundFile(1, 98, "Did I do that.mp3","")
	insertSoundFile(1, 99, "Did they give you an anal probe.mp3","")
	insertSoundFile(1, 100, "Did you hear what I said, fuck off.mp3","")
	insertSoundFile(1, 101, "Did you know I'm utterly insane.mp3","")
	insertSoundFile(1, 102, "Die you son of a bitch.mp3","")
	insertSoundFile(1, 103, "Die, you insect.mp3","")
	insertSoundFile(1, 104, "Do I make you horny baby.mp3","")
	insertSoundFile(1, 105, "Do not go in there, woooo.mp3","")
	insertSoundFile(1, 106, "Do you find it hard to hide the fact that you're gay.mp3","")
	insertSoundFile(1, 107, "Do you suck dicks.mp3","")
	insertSoundFile(1, 108, "Do you want to touch my monkey.mp3","")
	insertSoundFile(1, 109, "Do you, or do you not have a target.mp3","")
	insertSoundFile(1, 110, "Does this mean we're not friends anymore.mp3","")
	insertSoundFile(1, 111, "Doh B.mp3","")
	insertSoundFile(1, 112, "Don't be such a fucking chump.mp3","")
	insertSoundFile(1, 113, "Don't call me an asshole you son of a bitch.mp3","")
	insertSoundFile(1, 114, "Don't do that.mp3","")
	insertSoundFile(1, 115, "Don't fuck with the jedi master son.mp3","")
	insertSoundFile(1, 116, "Don't make me destroy you.mp3","")
	insertSoundFile(1, 117, "Don't make me kick your ass, mmmm k.mp3","")
	insertSoundFile(1, 118, "Don't mess with me, I'm one crazy mofo.mp3","")
	insertSoundFile(1, 119, "Don't mess with the bull young man, you'll get the horns.mp3","")
	insertSoundFile(1, 120, "Don't touch those, don't you ever touch my balls without asking.mp3","")
	insertSoundFile(1, 121, "Don't worry, I'm not going to hurt you, WHIP ahhhhh.mp3","")
	insertSoundFile(1, 122, "Don't you know I would never say the word FUCK.mp3","")
	insertSoundFile(1, 123, "Double kill.mp3","")
	insertSoundFile(1, 124, "Dude, decaf.mp3","")
	insertSoundFile(1, 125, "Dude, that is so fucking weak.mp3","")
	insertSoundFile(1, 126, "Dude, that kicked ass.mp3","")
	insertSoundFile(1, 127, "Due to some violent content, parental discretion is advised.mp3","")
	insertSoundFile(1, 128, "Eh, I'm sorry your answer must be in the form of a question.mp3","")
	insertSoundFile(1, 129, "English mother fucker, do you speak it.mp3","")
	insertSoundFile(1, 130, "Everybody and every creature has to poop some time.mp3","")
	insertSoundFile(1, 131, "Ew, aw dude.mp3","")
	insertSoundFile(1, 132, "Ew, that's disgusting.mp3","")
	insertSoundFile(1, 133, "Excellent, RIFF.mp3","")
	insertSoundFile(1, 134, "Excellent.mp3","")
	insertSoundFile(1, 135, "Excuse me, but I do believe that sucked ass.mp3","")
	insertSoundFile(1, 136, "Excuse me, you're ruining the magic.mp3","")
	insertSoundFile(1, 137, "Exterminate.mp3","")
	insertSoundFile(1, 138, "Fart ow.mp3","")
	insertSoundFile(1, 139, "Fear my leet skills.mp3","")
	insertSoundFile(1, 140, "Finally acknowledge that I'm the superior BEING.mp3","")
	insertSoundFile(1, 141, "Finish him.mp3","")
	insertSoundFile(1, 142, "First blood B.mp3","")
	insertSoundFile(1, 143, "Flawless victory B.mp3","")
	insertSoundFile(1, 144, "Fuck you asshole.mp3","")
	insertSoundFile(1, 145, "Fuck you B.mp3","")
	insertSoundFile(1, 146, "Fuck you fuck you fuck you, you're cool, and fuck you I'm out.mp3","")
	insertSoundFile(1, 147, "Fuck you, and the horse you rode in on.mp3","")
	insertSoundFile(1, 148, "Fuck you.mp3","")
	insertSoundFile(1, 149, "Fuck, it's either me or them, you're getting fucked one way or another.mp3","")
	insertSoundFile(1, 150, "Fuck.mp3","")
	insertSoundFile(1, 151, "Fucking eat shit mother fucker.mp3","")
	insertSoundFile(1, 152, "Gee golly gosh, I sure am sorry I offended you.mp3","")
	insertSoundFile(1, 153, "Get this through your head MOTHER.mp3","")
	insertSoundFile(1, 154, "Get to the chopper EXPLOSION.mp3","")
	insertSoundFile(1, 155, "Get with the fucking program.mp3","")
	insertSoundFile(1, 156, "Give me a buff so I can pwn like a pwn man.mp3","")
	insertSoundFile(1, 157, "Go fuck yourself.mp3","")
	insertSoundFile(1, 158, "Go go go.mp3","")
	insertSoundFile(1, 159, "God damn it I hate it I hate it.mp3","")
	insertSoundFile(1, 160, "God damn it, I'd piss on a spakplug if I thought it'd do any good.mp3","")
	insertSoundFile(1, 161, "God fucking damn it.mp3","")
	insertSoundFile(1, 162, "Good morning vietnam.mp3","")
	insertSoundFile(1, 163, "Good question, but I don't care.mp3","")
	insertSoundFile(1, 164, "Good show, jolly good show major.mp3","")
	insertSoundFile(1, 165, "Goodnight children.mp3","")
	insertSoundFile(1, 166, "Got has a hardon, because be kill everything we see.mp3","")
	insertSoundFile(1, 167, "Ha ha C.mp3","")
	insertSoundFile(1, 168, "Ha ha ha ha ha ha ha.mp3","")
	insertSoundFile(1, 169, "Ha ha ha ha ha, idiotic human.mp3","")
	insertSoundFile(1, 170, "Ha ha ha ha ha, shutup.mp3","")
	insertSoundFile(1, 171, "Ha ha.mp3","")
	insertSoundFile(1, 172, "Hail Satan, Hail Satan, Hail Satan, Hail Satan.mp3","")
	insertSoundFile(1, 173, "Hallelujah.mp3","")
	insertSoundFile(1, 174, "Happy for the rest of your LIFE.mp3","")
	insertSoundFile(1, 175, "Have you considered therapy.mp3","")
	insertSoundFile(1, 176, "Have you ever heard the expression, the customer is always right.mp3","")
	insertSoundFile(1, 177, "He he he he he he he he.mp3","")
	insertSoundFile(1, 178, "He's dead Jim.mp3","")
	insertSoundFile(1, 179, "He's evil I tell you, evil.mp3","")
	insertSoundFile(1, 180, "He's gonna take a leak, get out of the way.mp3","")
	insertSoundFile(1, 181, "Headshot B.mp3","")
	insertSoundFile(1, 182, "Headshot.mp3","")
	insertSoundFile(1, 183, "Hear you nothing that I say.mp3","")
	insertSoundFile(1, 184, "Hee hee, I win, in your face, ya, how do you like them apples.mp3","")
	insertSoundFile(1, 185, "Hell I like you, you can come over to my house and fuck my sister.mp3","")
	insertSoundFile(1, 186, "Help you I can, yes, mmmmmmm.mp3","")
	insertSoundFile(1, 187, "Here I come to say the day.mp3","")
	insertSoundFile(1, 188, "Here's a nice piece of shit.mp3","")
	insertSoundFile(1, 189, "Hey bud, what's your problem.mp3","")
	insertSoundFile(1, 190, "Hey guys, how's it goin'.mp3","")
	insertSoundFile(1, 191, "Hey hang on you guys, I'll be right back TAKING A DUMP.mp3","")
	insertSoundFile(1, 192, "Hey hey, you wanna join my guild.mp3","")
	insertSoundFile(1, 193, "Hey try not to suck any dick on the way from the parking lot.mp3","")
	insertSoundFile(1, 194, "Hey, how you doin.mp3","")
	insertSoundFile(1, 195, "Hey, look who's back.mp3","")
	insertSoundFile(1, 196, "Hey, what's wrong baby.mp3","")
	insertSoundFile(1, 197, "Hey, you made me spill my beer.mp3","")
	insertSoundFile(1, 198, "Hi shmoopy.mp3","")
	insertSoundFile(1, 199, "Hi tushy.mp3","")
	insertSoundFile(1, 200, "Hold on, let me get high.mp3","")
	insertSoundFile(1, 201, "Holy crap, that's awesome.mp3","")
	insertSoundFile(1, 202, "Holy fucking shit.mp3","")
	insertSoundFile(1, 203, "Hot damn.mp3","")
	insertSoundFile(1, 204, "Houston, we have a problem.mp3","")
	insertSoundFile(1, 205, "How many assholes we got on this ship anyhow.mp3","")
	insertSoundFile(1, 206, "Howdy ho.mp3","")
	insertSoundFile(1, 207, "Huh.mp3","")
	insertSoundFile(1, 208, "Humiliation.mp3","")
	insertSoundFile(1, 209, "I am invincible, invincible, ye ow.mp3","")
	insertSoundFile(1, 210, "I am invincible.mp3","")
	insertSoundFile(1, 211, "I am shocked and shagrined, mortified and stupified.mp3","")
	insertSoundFile(1, 212, "I am so smart, I am so smart, S M R T, I mean S M A R T.mp3","")
	insertSoundFile(1, 213, "I am the bigger and the stronger of all the girly men.mp3","")
	insertSoundFile(1, 214, "I believe you have my stapler.mp3","")
	insertSoundFile(1, 215, "I bet your the kind of guy to fuck a person in the ass REACHAROUND.mp3","")
	insertSoundFile(1, 216, "I cannot accept that course of action.mp3","")
	insertSoundFile(1, 217, "I did not.mp3","")
	insertSoundFile(1, 218, "I didn't do it.mp3","")
	insertSoundFile(1, 219, "I do the asskicking around here.mp3","")
	insertSoundFile(1, 220, "I don't give a fuck.mp3","")
	insertSoundFile(1, 221, "I don't know what I'd say, but if I don't die, I will be a success.mp3","")
	insertSoundFile(1, 222, "I don't know.mp3","")
	insertSoundFile(1, 223, "I don't play well with others.mp3","")
	insertSoundFile(1, 224, "I don't remember askin' you a god damn thing.mp3","")
	insertSoundFile(1, 225, "I don't think that's funny.mp3","")
	insertSoundFile(1, 226, "I don't understand this fucking question.mp3","")
	insertSoundFile(1, 227, "I fart in your general direction.mp3","")
	insertSoundFile(1, 228, "I fart on your grave.mp3","")
	insertSoundFile(1, 229, "I got 99 problems, but a bitch ain't one.mp3","")
	insertSoundFile(1, 230, "I got no problem with that.mp3","")
	insertSoundFile(1, 231, "I guess I'm just not smart enough.mp3","")
	insertSoundFile(1, 232, "I guess I'm really fucked now.mp3","")
	insertSoundFile(1, 233, "I hate those frickin' things.mp3","")
	insertSoundFile(1, 234, "I have come here to chew bubble gum and kick ass, and I'm all out of bubblegum.mp3","")
	insertSoundFile(1, 235, "I have no time for the jibber jabber.mp3","")
	insertSoundFile(1, 236, "I haven't got time, for this Mickey Mouse bullshit.mp3","")
	insertSoundFile(1, 237, "I just can't do it captain, I don't have the power.mp3","")
	insertSoundFile(1, 238, "I knew it, I'm surrounded by assholes.mp3","")
	insertSoundFile(1, 239, "I love crack, I'm absolutely cuckoo for crack.mp3","")
	insertSoundFile(1, 240, "I love it when a plan comes together.mp3","")
	insertSoundFile(1, 241, "I love you man.mp3","")
	insertSoundFile(1, 242, "I pity myself that I gotta be with these fools.mp3","")
	insertSoundFile(1, 243, "I say we blow the fuckers up.mp3","")
	insertSoundFile(1, 244, "I see dead people.mp3","")
	insertSoundFile(1, 245, "I smell varmint poontang.mp3","")
	insertSoundFile(1, 246, "I suggest you run away, fast.mp3","")
	insertSoundFile(1, 247, "I think I speak for everyone here when I say huh.mp3","")
	insertSoundFile(1, 248, "I think I tore my sack.mp3","")
	insertSoundFile(1, 249, "I think we got a hacker.mp3","")
	insertSoundFile(1, 250, "I think you need your balls reattached.mp3","")
	insertSoundFile(1, 251, "I think, I shall now be sick.mp3","")
	insertSoundFile(1, 252, "I threw my back out humping your mom last night.mp3","")
	insertSoundFile(1, 253, "I uh, I don't like my job, and uh I don't think I'm going to go anymore.mp3","")
	insertSoundFile(1, 254, "I want my baby back baby back baby back RIBS.mp3","")
	insertSoundFile(1, 255, "I was abused too man.mp3","")
	insertSoundFile(1, 256, "I wouldn't bet on it, crazy man.mp3","")
	insertSoundFile(1, 257, "I'll be back.mp3","")
	insertSoundFile(1, 258, "I'll be damned if I'm gonna clean up this mess.mp3","")
	insertSoundFile(1, 259, "I'll be watchin you.mp3","")
	insertSoundFile(1, 260, "I'll blow this place up and be home in time for corn flakes.mp3","")
	insertSoundFile(1, 261, "I'll buy that for a dollar.mp3","")
	insertSoundFile(1, 262, "I'll cut off your johnson.mp3","")
	insertSoundFile(1, 263, "I'll stomp all you girly monsters.mp3","")
	insertSoundFile(1, 264, "I'm 10 years old but I'll beat your ass.mp3","")
	insertSoundFile(1, 265, "I'm about to piss mysself.mp3","")
	insertSoundFile(1, 266, "I'm afraid that's something I cannot allow to happen.mp3","")
	insertSoundFile(1, 267, "I'm back baby.mp3","")
	insertSoundFile(1, 268, "I'm funny how, HERE TO AMUSE YOU.mp3","")
	insertSoundFile(1, 269, "I'm going to kill you.mp3","")
	insertSoundFile(1, 270, "I'm gonna barbecue your ass.mp3","")
	insertSoundFile(1, 271, "I'm gonna get you boy.mp3","")
	insertSoundFile(1, 272, "I'm gonna have to open a can of whoop ass on you now.mp3","")
	insertSoundFile(1, 273, "I'm gonna show you how to kick ass.mp3","")
	insertSoundFile(1, 274, "I'm gonna shut that big mouth of yours.mp3","")
	insertSoundFile(1, 275, "I'm gonna to spank you like a little red headed stepchild.mp3","")
	insertSoundFile(1, 276, "I'm having bad dreams, and I poop a lot.mp3","")
	insertSoundFile(1, 277, "I'm just gonna step outside and go wee wee.mp3","")
	insertSoundFile(1, 278, "I'm just trying to get a rise out of you that's all, for shits and giggles.mp3","")
	insertSoundFile(1, 279, "I'm not to be triffled with.mp3","")
	insertSoundFile(1, 280, "I'm on your lilke stink on shit.mp3","")
	insertSoundFile(1, 281, "I'm outta here.mp3","")
	insertSoundFile(1, 282, "I'm sexy, I'm cute, I'm popular to boot.mp3","")
	insertSoundFile(1, 283, "I'm so wasted.mp3","")
	insertSoundFile(1, 284, "I'm sorry, I'm sorry.mp3","")
	insertSoundFile(1, 285, "I'm sorry.mp3","")
	insertSoundFile(1, 286, "I'm very disappointed.mp3","")
	insertSoundFile(1, 287, "I'm waiting.mp3","")
	insertSoundFile(1, 288, "I, am surrounded by freaks.mp3","")
	insertSoundFile(1, 289, "If I may be so blunt, who gives a shit.mp3","")
	insertSoundFile(1, 290, "If it bleeds, we can kill it.mp3","")
	insertSoundFile(1, 291, "If that happens once more, I'm gonna have your balls for breakfast ok, yeah Denny's style, ok.mp3","")
	insertSoundFile(1, 292, "If you can't be at least mildly interesting, then shut the hell up.mp3","")
	insertSoundFile(1, 293, "Impressive.mp3","")
	insertSoundFile(1, 294, "In-fuckin-credible.mp3","")
	insertSoundFile(1, 295, "Inconceivable.mp3","")
	insertSoundFile(1, 296, "Is it possible for you to shut the fuck up for ten seconds.mp3","")
	insertSoundFile(1, 297, "Is it wrong that I was totally aroused by that.mp3","")
	insertSoundFile(1, 298, "Is there any way of getting in and out of this place without this happening all the time.mp3","")
	insertSoundFile(1, 299, "It doesn't make any sense, any fucking sense.mp3","")
	insertSoundFile(1, 300, "It isn't fair, you god damn assholes, it isn't fair.mp3","")
	insertSoundFile(1, 301, "It's alive, it's alive, it's alive.mp3","")
	insertSoundFile(1, 302, "It's all a bunch of tree hugging hippy crap.mp3","")
	insertSoundFile(1, 303, "It's impossible.mp3","")
	insertSoundFile(1, 304, "It's just a flesh wound.mp3","")
	insertSoundFile(1, 305, "It's no hassle SHH.mp3","")
	insertSoundFile(1, 306, "It's not the size of the hammer that counts, it's how you wield it.mp3","")
	insertSoundFile(1, 307, "It's official, you suck.mp3","")
	insertSoundFile(1, 308, "It's soo big, ahem.mp3","")
	insertSoundFile(1, 309, "It's such a shame you can't see what finger I'm holding up.mp3","")
	insertSoundFile(1, 310, "Jesus christ, who do the fuck do you think you're talking to.mp3","")
	insertSoundFile(1, 311, "Jesus, I gotta learn how to fight, this is pathetic.mp3","")
	insertSoundFile(1, 312, "Just when I think you've said the stupidest thing ever, you keep talkin'.mp3","")
	insertSoundFile(1, 313, "Kick ass.mp3","")
	insertSoundFile(1, 314, "Kick him.mp3","")
	insertSoundFile(1, 315, "Killing spree B.mp3","")
	insertSoundFile(1, 316, "Kiss my entire ass.mp3","")
	insertSoundFile(1, 317, "Kiss my sagging ass.mp3","")
	insertSoundFile(1, 318, "Kisses.mp3","")
	insertSoundFile(1, 319, "Lap dogs, all of you.mp3","")
	insertSoundFile(1, 320, "Less talk and more action.mp3","")
	insertSoundFile(1, 321, "Let a man take a crap.mp3","")
	insertSoundFile(1, 322, "Let this be a reminder to you all, that this organization will not tolerate failure.mp3","")
	insertSoundFile(1, 323, "Lets get ready to rumble.mp3","")
	insertSoundFile(1, 324, "Light sabres.mp3","")
	insertSoundFile(1, 325, "Light, give me strength.mp3","")
	insertSoundFile(1, 326, "Look at me, I'm happy.mp3","")
	insertSoundFile(1, 327, "Look at the screen you dumb shit, I'm trying to get your attention.mp3","")
	insertSoundFile(1, 328, "Looks like I picked the wrong week to quit amphetamines.mp3","")
	insertSoundFile(1, 329, "Looks like I picked the wrong week to quit smoking.mp3","")
	insertSoundFile(1, 330, "Looser.mp3","")
	insertSoundFile(1, 331, "Ludicrous kill.mp3","")
	insertSoundFile(1, 332, "Man that's crap.mp3","")
	insertSoundFile(1, 333, "Man, you are one pathetic loser.mp3","")
	insertSoundFile(1, 334, "Maybe I'm losing my sex appeal.mp3","")
	insertSoundFile(1, 335, "Me so horny.mp3","")
	insertSoundFile(1, 336, "Medic.mp3","")
	insertSoundFile(1, 337, "Monster kill.mp3","")
	insertSoundFile(1, 338, "More dots, throw more dots, more dots, more dots, come on more dots.mp3","")
	insertSoundFile(1, 339, "Most humble and grateful, thanks to you.mp3","")
	insertSoundFile(1, 340, "Move it move it move it.mp3","")
	insertSoundFile(1, 341, "Multikill.mp3","")
	insertSoundFile(1, 342, "My advice to you, start drinking heavily.mp3","")
	insertSoundFile(1, 343, "My balls are burning.mp3","")
	insertSoundFile(1, 344, "My bunghole hole, it goes BRACACACA.mp3","")
	insertSoundFile(1, 345, "My business, is done.mp3","")
	insertSoundFile(1, 346, "My dad says you're a joke and I don't have to listen to you, fuck off.mp3","")
	insertSoundFile(1, 347, "My nipples are hard just thinking about it.mp3","")
	insertSoundFile(1, 348, "Name your poison.mp3","")
	insertSoundFile(1, 349, "Nice move, beautifully done.mp3","")
	insertSoundFile(1, 350, "No no no B.mp3","")
	insertSoundFile(1, 351, "No no no.mp3","")
	insertSoundFile(1, 352, "No problemo.mp3","")
	insertSoundFile(1, 353, "No soup for you.mp3","")
	insertSoundFile(1, 354, "No way.mp3","")
	insertSoundFile(1, 355, "No.mp3","")
	insertSoundFile(1, 356, "Nooooo B.mp3","")
	insertSoundFile(1, 357, "Nooooo.mp3","")
	insertSoundFile(1, 358, "Now I have to face stupid reality again.mp3","")
	insertSoundFile(1, 359, "Now it is time to play.mp3","")
	insertSoundFile(1, 360, "Now lets all get drunk and play ping pong.mp3","")
	insertSoundFile(1, 361, "Now was that smart, shrood, good tactics, or STUPID.mp3","")
	insertSoundFile(1, 362, "Now you see that evil will always triumph, because good is dumb.mp3","")
	insertSoundFile(1, 363, "Now, are you sitting comfortably, good, then we'll begin.mp3","")
	insertSoundFile(1, 364, "Now, that was some straight up David Copperfield shit.mp3","")
	insertSoundFile(1, 365, "Oh god, oh god, oh oh my god.mp3","")
	insertSoundFile(1, 366, "Oh jesus, RESIST THE ASS.mp3","")
	insertSoundFile(1, 367, "Oh my god, what the hell is that thing.mp3","")
	insertSoundFile(1, 368, "Oh my god, you sick little monkey.mp3","")
	insertSoundFile(1, 369, "Oh my god.mp3","")
	insertSoundFile(1, 370, "Oh shit B.mp3","")
	insertSoundFile(1, 371, "Oh shit.mp3","")
	insertSoundFile(1, 372, "Oh well, plan b, lets just kill each other.mp3","")
	insertSoundFile(1, 373, "Oh what are you gonna do ya pervert.mp3","")
	insertSoundFile(1, 374, "Oh yeah baby.mp3","")
	insertSoundFile(1, 375, "Oh yeah.mp3","")
	insertSoundFile(1, 376, "Oh you people can kiss the fattest part of my ass.mp3","")
	insertSoundFile(1, 377, "Oh, behave.mp3","")
	insertSoundFile(1, 378, "Oh, bitch.mp3","")
	insertSoundFile(1, 379, "Oh, blow it out your ass.mp3","")
	insertSoundFile(1, 380, "Oh, don't be a party pooper.mp3","")
	insertSoundFile(1, 381, "Oh, I'm so scared.mp3","")
	insertSoundFile(1, 382, "Oh, I'm sorry, did I break your concentration.mp3","")
	insertSoundFile(1, 383, "Oh, I'm sorry, you're crying like a woman.mp3","")
	insertSoundFile(1, 384, "Oh, who did this to you, this is just not right, in fact it's nasty.mp3","")
	insertSoundFile(1, 385, "Oh, you shit faced cock master.mp3","")
	insertSoundFile(1, 386, "Oh, you think so.mp3","")
	insertSoundFile(1, 387, "Oh, you're so bad.mp3","")
	insertSoundFile(1, 388, "Ok, everybody get in a line so I can whoop all your asses.mp3","")
	insertSoundFile(1, 389, "Ok, that does it, screw you guys I'm going home.mp3","")
	insertSoundFile(1, 390, "Ok, that was a good practice children, we'll see you hear again tomorrow.mp3","")
	insertSoundFile(1, 391, "Okay, bendover.mp3","")
	insertSoundFile(1, 392, "One of us is in deep trouble.mp3","")
	insertSoundFile(1, 393, "Oooh, frisky are we.mp3","")
	insertSoundFile(1, 394, "Oooh, he-yeah, this is too easy.mp3","")
	insertSoundFile(1, 395, "Oooh, hurt me baby.mp3","")
	insertSoundFile(1, 396, "Oooh, I like it.mp3","")
	insertSoundFile(1, 397, "Oooh, I'm sensing some hostility.mp3","")
	insertSoundFile(1, 398, "Oooh, nasty.mp3","")
	insertSoundFile(1, 399, "Oooh, that's gotta hurt.mp3","")
	insertSoundFile(1, 400, "Oops.mp3","")
	insertSoundFile(1, 401, "Open fire.mp3","")
	insertSoundFile(1, 402, "Ouch.mp3","")
	insertSoundFile(1, 403, "Out of my way dumb dumb, I'm gonna kick some butt.mp3","")
	insertSoundFile(1, 404, "Ow HOMER IN SEVER PAIN.mp3","")
	insertSoundFile(1, 405, "Ow, you shot me, you ahole.mp3","")
	insertSoundFile(1, 406, "Pardon my french, but you're an asshole.mp3","")
	insertSoundFile(1, 407, "Payback's a motha fuck ain't it.mp3","")
	insertSoundFile(1, 408, "Peon, That's it, I'm dead.mp3","")
	insertSoundFile(1, 409, "Personally, I think you're a fucking idiot.mp3","")
	insertSoundFile(1, 410, "Plop plop fizz fizz oh what a relief it is.mp3","")
	insertSoundFile(1, 411, "Prepare to attack, all hands, battle stations.mp3","")
	insertSoundFile(1, 412, "Prepare to die.mp3","")
	insertSoundFile(1, 413, "Prepare to fight.mp3","")
	insertSoundFile(1, 414, "Put down your weapon, you have 20 seconds to comply.mp3","")
	insertSoundFile(1, 415, "Questing for fuckin FUN.mp3","")
	insertSoundFile(1, 416, "Ra ha ha.mp3","")
	insertSoundFile(1, 417, "Rampage.mp3","")
	insertSoundFile(1, 418, "Relax toots, don't get your panties in a bunch.mp3","")
	insertSoundFile(1, 419, "Remember Sally when I promised to kill you last, I lied.mp3","")
	insertSoundFile(1, 420, "Revenge is so very very sweet.mp3","")
	insertSoundFile(1, 421, "Rofl.mp3","")
	insertSoundFile(1, 422, "Roger that.mp3","")
	insertSoundFile(1, 423, "Run away.mp3","")
	insertSoundFile(1, 424, "Run for your life.mp3","")
	insertSoundFile(1, 425, "Run forest run.mp3","")
	insertSoundFile(1, 426, "Run home and cry to momma.mp3","")
	insertSoundFile(1, 427, "Say hello to my little friend.mp3","")
	insertSoundFile(1, 428, "Say what again, say what again, MOTHA FUCKER.mp3","")
	insertSoundFile(1, 429, "Screw you guys, I'm going home.mp3","")
	insertSoundFile(1, 430, "Screw you hippy.mp3","")
	insertSoundFile(1, 431, "Shall we play a game.mp3","")
	insertSoundFile(1, 432, "Shall we shag now, or shall we shag later.mp3","")
	insertSoundFile(1, 433, "Shit.mp3","")
	insertSoundFile(1, 434, "Shitting on the toilet for an extraordinary long amount of time.mp3","")
	insertSoundFile(1, 435, "Shut up you little slut.mp3","")
	insertSoundFile(1, 436, "Shut your noise tube.mp3","")
	insertSoundFile(1, 437, "Shutup dildo.mp3","")
	insertSoundFile(1, 438, "Shutup fool.mp3","")
	insertSoundFile(1, 439, "Silence, you mental midget.mp3","")
	insertSoundFile(1, 440, "So, are we gonna screw soon, cause I'm gettin' kind of antsy.mp3","")
	insertSoundFile(1, 441, "Something is broke, and it's not your fault.mp3","")
	insertSoundFile(1, 442, "Son let me tell you a story about a young man who came here and FAILED.mp3","")
	insertSoundFile(1, 443, "Son of a bitch.mp3","")
	insertSoundFile(1, 444, "SONG Another One Bites The Dust.mp3","")
	insertSoundFile(1, 445, "SONG Benny Hill.mp3","")
	insertSoundFile(1, 446, "SONG Darth Vader.mp3","")
	insertSoundFile(1, 447, "SONG Go Go PowerRangers.mp3","")
	insertSoundFile(1, 448, "SONG I Feel Good.mp3","")
	insertSoundFile(1, 449, "SONG Live To Win.mp3","")
	insertSoundFile(1, 450, "SONG Mission Impossible.mp3","")
	insertSoundFile(1, 451, "SONG Star Wars.mp3","")
	insertSoundFile(1, 452, "SONG Staying Alive.mp3","")
	insertSoundFile(1, 453, "SONG Twilight Zone.mp3","")
	insertSoundFile(1, 454, "SOUND Applause.mp3","")
	insertSoundFile(1, 455, "SOUND Austin Laugh.mp3","")
	insertSoundFile(1, 456, "SOUND Beavis Laugh.mp3","")
	insertSoundFile(1, 457, "SOUND Boing.mp3","")
	insertSoundFile(1, 458, "SOUND Cat meow.mp3","")
	insertSoundFile(1, 459, "SOUND Chaching.mp3","")
	insertSoundFile(1, 460, "SOUND Chicken charge.mp3","")
	insertSoundFile(1, 461, "SOUND Cough.mp3","")
	insertSoundFile(1, 462, "SOUND Crickets.mp3","")
	insertSoundFile(1, 463, "SOUND Dragnet.mp3","")
	insertSoundFile(1, 464, "SOUND Duck quacking.mp3","")
	insertSoundFile(1, 465, "SOUND Dukes Of Hazard Horn.mp3","")
	insertSoundFile(1, 466, "SOUND Fan Fare Music.mp3","")
	insertSoundFile(1, 467, "SOUND Fart.mp3","")
	insertSoundFile(1, 468, "SOUND Farts.mp3","")
	insertSoundFile(1, 469, "SOUND Goat.mp3","")
	insertSoundFile(1, 470, "SOUND Godzilla Roar.mp3","")
	insertSoundFile(1, 471, "SOUND Homer Despair.mp3","")
	insertSoundFile(1, 472, "SOUND Old Western Showdown.mp3","")
	insertSoundFile(1, 473, "SOUND Sheep.mp3","")
	insertSoundFile(1, 474, "SOUND Snare.mp3","")
	insertSoundFile(1, 475, "SOUND Snore.mp3","")
	insertSoundFile(1, 476, "SOUND Star Wars, Blaster.mp3","")
	insertSoundFile(1, 477, "SOUND Star Wars, Chewy.mp3","")
	insertSoundFile(1, 478, "SOUND Star Wars, Tuskan Animal.mp3","")
	insertSoundFile(1, 479, "SOUND Stutter.mp3","")
	insertSoundFile(1, 480, "SOUND Super Mario, Death.mp3","")
	insertSoundFile(1, 481, "SOUND Tarzan Yell.mp3","")
	insertSoundFile(1, 482, "SOUND Transformers, Scene Transition.mp3","")
	insertSoundFile(1, 483, "SOUND Turkey gobble.mp3","")
	insertSoundFile(1, 484, "SOUND Whip crack.mp3","")
	insertSoundFile(1, 485, "Sounds like a really crappy plan, but ok.mp3","")
	insertSoundFile(1, 486, "Sounds like somebody's got a case of the Monday's.mp3","")
	insertSoundFile(1, 487, "Stay on target, stay on target.mp3","")
	insertSoundFile(1, 488, "Step down here and say that sucker.mp3","")
	insertSoundFile(1, 489, "Stings the nostrils, in a good way.mp3","")
	insertSoundFile(1, 490, "Stop it, stop what you're doing.mp3","")
	insertSoundFile(1, 491, "Stop running you fat slimeball.mp3","")
	insertSoundFile(1, 492, "Stop whining.mp3","")
	insertSoundFile(1, 493, "Stupid, you're so stupid.mp3","")
	insertSoundFile(1, 494, "Sucky sucky 5 dollar.mp3","")
	insertSoundFile(1, 495, "Superb.mp3","")
	insertSoundFile(1, 496, "Surprise asshole, I bet you never saw this coming.mp3","")
	insertSoundFile(1, 497, "Swallow it and shut the fuck up.mp3","")
	insertSoundFile(1, 498, "Sweet merciful crap.mp3","")
	insertSoundFile(1, 499, "Sweet mother of god, what is the holdup.mp3","")
	insertSoundFile(1, 500, "Sweet.mp3","")
	insertSoundFile(1, 501, "Ta ra ra boom de yay, did you get yours today, that's why I walk this WAY.mp3","")
	insertSoundFile(1, 502, "Take it easy when you talk to me okay.mp3","")
	insertSoundFile(1, 503, "Take that pecker head.mp3","")
	insertSoundFile(1, 504, "Take that spaceboy.mp3","")
	insertSoundFile(1, 505, "Test your might.mp3","")
	insertSoundFile(1, 506, "Thank You Mr Know It All.mp3","")
	insertSoundFile(1, 507, "Thank you very much.mp3","")
	insertSoundFile(1, 508, "That crazy dancin makin' my penis soft.mp3","")
	insertSoundFile(1, 509, "That felt like a round from an AK-47.mp3","")
	insertSoundFile(1, 510, "That makes me angry, mr biggles WORTH.mp3","")
	insertSoundFile(1, 511, "That piece of shit up there I never liked him I never trusted him.mp3","")
	insertSoundFile(1, 512, "That son of a bitch.mp3","")
	insertSoundFile(1, 513, "That sounds pretty sweet to me.mp3","")
end

function insertSoundPack02SoundFiles()
	insertSoundFile(2, 514, "That was pathetic.mp3","")
	insertSoundFile(2, 515, "That's all folks.mp3","")
	insertSoundFile(2, 516, "That's deplorable, unfathomable, improbable.mp3","")
	insertSoundFile(2, 517, "That's it, I'm dead.mp3","")
	insertSoundFile(2, 518, "That's it, I'm outta here.mp3","")
	insertSoundFile(2, 519, "That's it, screw this game.mp3","")
	insertSoundFile(2, 520, "That's my name don't wear it out.mp3","")
	insertSoundFile(2, 521, "That's okay, no big deal.mp3","")
	insertSoundFile(2, 522, "That's right you selfish asshole.mp3","")
	insertSoundFile(2, 523, "That's right, big yankee devil make bang bang all over your ass.mp3","")
	insertSoundFile(2, 524, "That's some language you got there.mp3","")
	insertSoundFile(2, 525, "The best things in life are worth waiting for.mp3","")
	insertSoundFile(2, 526, "The following people are gay.mp3","")
	insertSoundFile(2, 527, "The hell are you doin'.mp3","")
	insertSoundFile(2, 528, "The next time I have to come in here, I'm cracking skulls.mp3","")
	insertSoundFile(2, 529, "The price is wrong bitch.mp3","")
	insertSoundFile(2, 530, "There's an imposter amongst us, and he touched my ass.mp3","")
	insertSoundFile(2, 531, "They're all dead, they just don't know it yet.mp3","")
	insertSoundFile(2, 532, "This is a lovely room of death, take care now, bye bye the.mp3","")
	insertSoundFile(2, 533, "This is like the gun I used in nam.mp3","")
	insertSoundFile(2, 534, "This is my rifle, this is my gun, this is my fighting, this is for fun.mp3","")
	insertSoundFile(2, 535, "This is not goodbye, it's just I won't ever see you again.mp3","")
	insertSoundFile(2, 536, "This is so not right.mp3","")
	insertSoundFile(2, 537, "This is some bullshit.mp3","")
	insertSoundFile(2, 538, "This is some fucked up repugnant shit.mp3","")
	insertSoundFile(2, 539, "This is the sound a doggy makes, mr connery, moo, no.mp3","")
	insertSoundFile(2, 540, "This is the worst moment of my entire life.mp3","")
	insertSoundFile(2, 541, "This sucks I'm outta here.mp3","")
	insertSoundFile(2, 542, "This town needs an enema.mp3","")
	insertSoundFile(2, 543, "Timmy rant.mp3","")
	insertSoundFile(2, 544, "To alcohol, the cause of, and solution to, all of life's problems.mp3","")
	insertSoundFile(2, 545, "To call you stupid, would be an insult to stupid people.mp3","")
	insertSoundFile(2, 546, "Turn off that god damn music.mp3","")
	insertSoundFile(2, 547, "Uh oh, we're in trouble.mp3","")
	insertSoundFile(2, 548, "Uh, huh huh huh huh, I dunno.mp3","")
	insertSoundFile(2, 549, "Unzipping pants and sporting a woody.mp3","")
	insertSoundFile(2, 550, "Use your fucking brain.mp3","")
	insertSoundFile(2, 551, "Vacuous, toffee nosed, PERVERT.mp3","")
	insertSoundFile(2, 552, "Very very exciting. some close calls huh.mp3","")
	insertSoundFile(2, 553, "Wanna waste my time ok.mp3","")
	insertSoundFile(2, 554, "Was that a cheezy poof.mp3","")
	insertSoundFile(2, 555, "Watch my back.mp3","")
	insertSoundFile(2, 556, "We are sexy, we are sexy bitches, yeah.mp3","")
	insertSoundFile(2, 557, "We came, we saw, we kicked its ass.mp3","")
	insertSoundFile(2, 558, "We Have A Winner.mp3","")
	insertSoundFile(2, 559, "We have found a witch, may we burn her.mp3","")
	insertSoundFile(2, 560, "We need reinforcements from the cafe.mp3","")
	insertSoundFile(2, 561, "We tried to stab them shoot them, smash them, smoosh them... lets face it darling, we suck.mp3","")
	insertSoundFile(2, 562, "We're doomed.mp3","")
	insertSoundFile(2, 563, "We're getting slaughtered.mp3","")
	insertSoundFile(2, 564, "We're gonna do it, and it's gonna be magical.mp3","")
	insertSoundFile(2, 565, "Well done.mp3","")
	insertSoundFile(2, 566, "Well he won't chase us anymore.mp3","")
	insertSoundFile(2, 567, "Well hello Mr Fancy Pants.mp3","")
	insertSoundFile(2, 568, "Well now, I wonder who would send a ninja here.mp3","")
	insertSoundFile(2, 569, "Well thank you.mp3","")
	insertSoundFile(2, 570, "Well this whole place sucks, that's right, it sucks.mp3","")
	insertSoundFile(2, 571, "Well, boo fucking hoo.mp3","")
	insertSoundFile(2, 572, "Well, la dee frickin dah.mp3","")
	insertSoundFile(2, 573, "Were you born a fat slimey scumbug you piece of shit, or did you have to work on it.mp3","")
	insertSoundFile(2, 574, "What a dirty filthy mind you've got.mp3","")
	insertSoundFile(2, 575, "What a dumbass.mp3","")
	insertSoundFile(2, 576, "What ain't no country I ever heard of, they speak english in what.mp3","")
	insertSoundFile(2, 577, "What are you gonna do, bleed on me.mp3","")
	insertSoundFile(2, 578, "What are you looking at butthead.mp3","")
	insertSoundFile(2, 579, "What are you, a fuckin' moron.mp3","")
	insertSoundFile(2, 580, "What country you from.mp3","")
	insertSoundFile(2, 581, "What did you say.mp3","")
	insertSoundFile(2, 582, "What have we got here, a fucking comedian.mp3","")
	insertSoundFile(2, 583, "What if I was just to kick the everlovin' shit out of you.mp3","")
	insertSoundFile(2, 584, "What is going on here, I demand an explanation.mp3","")
	insertSoundFile(2, 585, "What is the air-speed velocity of an unladen swallow BIT.mp3","")
	insertSoundFile(2, 586, "What is youur major malfunction, numbnuts.mp3","")
	insertSoundFile(2, 587, "What the fuck is that.mp3","")
	insertSoundFile(2, 588, "What the fuck is this.mp3","")
	insertSoundFile(2, 589, "What the fuck man, come on.mp3","")
	insertSoundFile(2, 590, "What the fudge are you doin.mp3","")
	insertSoundFile(2, 591, "What the hell are you doing you little freak.mp3","")
	insertSoundFile(2, 592, "What the hell does that have to do with anything.mp3","")
	insertSoundFile(2, 593, "What we've got here is, failure to communicate.mp3","")
	insertSoundFile(2, 594, "What you fuckin' high or what.mp3","")
	insertSoundFile(2, 595, "What's a matter.mp3","")
	insertSoundFile(2, 596, "What's happening.mp3","")
	insertSoundFile(2, 597, "What's my name, say my name bitch.mp3","")
	insertSoundFile(2, 598, "What's that smell, ooh, I know that smell.mp3","")
	insertSoundFile(2, 599, "What's wrong dude, you yella.mp3","")
	insertSoundFile(2, 600, "What's your name scumbag.mp3","")
	insertSoundFile(2, 601, "What, you think you're better than me, cause you got both your nuts.mp3","")
	insertSoundFile(2, 602, "Where the hell did that come from, what's going on here.mp3","")
	insertSoundFile(2, 603, "Who are you, what is all this.mp3","")
	insertSoundFile(2, 604, "Who gives a shit, get a fucking life.mp3","")
	insertSoundFile(2, 605, "Who is your daddy, and what does he do.mp3","")
	insertSoundFile(2, 606, "Who is your daddy.mp3","")
	insertSoundFile(2, 607, "Who is, about to take your head off.mp3","")
	insertSoundFile(2, 608, "Who the fuck said that.mp3","")
	insertSoundFile(2, 609, "Who the fuck was that.mp3","")
	insertSoundFile(2, 610, "Who the hell are you talking to son.mp3","")
	insertSoundFile(2, 611, "Who's the slimey little ... DEATH WARRANT.mp3","")
	insertSoundFile(2, 612, "Whoa whoa whoa whoa stop right there.mp3","")
	insertSoundFile(2, 613, "Whoo whoo whoo, you sound like a big choo choo train.mp3","")
	insertSoundFile(2, 614, "Why didn't somebody tell me my ass was so big.mp3","")
	insertSoundFile(2, 615, "Why do you block my axe with your body.mp3","")
	insertSoundFile(2, 616, "Why do you smell like butt.mp3","")
	insertSoundFile(2, 617, "Why don't you go outside and play hide and go fuck yourself.mp3","")
	insertSoundFile(2, 618, "Why don't you kiss my ass.mp3","")
	insertSoundFile(2, 619, "Why the hell didn't you tell me that from the beginning.mp3","")
	insertSoundFile(2, 620, "Wicked sick.mp3","")
	insertSoundFile(2, 621, "Woah, I'm getting a boner, I'm getting a stiffy.mp3","")
	insertSoundFile(2, 622, "Woah, no touchy, no touchy.mp3","")
	insertSoundFile(2, 623, "Woohoo.mp3","")
	insertSoundFile(2, 624, "Wooo hoo hoo.mp3","")
	insertSoundFile(2, 625, "Wooooooo, you know he dead.mp3","")
	insertSoundFile(2, 626, "Yeah sure, whatever.mp3","")
	insertSoundFile(2, 627, "Yeah, go home you little dildo.mp3","")
	insertSoundFile(2, 628, "Yeah, I'm so excited, all six of my nipples are tingling.mp3","")
	insertSoundFile(2, 629, "Yeah, so now you're a pussy, puss-a-holic.mp3","")
	insertSoundFile(2, 630, "Yeah, who's the juggernaut bitch.mp3","")
	insertSoundFile(2, 631, "Yeah, you like that.mp3","")
	insertSoundFile(2, 632, "Yeah, your head may be big, but I can still kick your ass.mp3","")
	insertSoundFile(2, 633, "Yes it's true, this man has no dick.mp3","")
	insertSoundFile(2, 634, "Yes yes, oh yeah, can you feel that buddy.mp3","")
	insertSoundFile(2, 635, "Yes, and I'd have gotten away with it too, if it wasn't for these blasted kids and their dogs.mp3","")
	insertSoundFile(2, 636, "Yes.mp3","")
	insertSoundFile(2, 637, "Yippy ki yay mother fucker.mp3","")
	insertSoundFile(2, 638, "Yo, she bitch, lets go.mp3","")
	insertSoundFile(2, 639, "You a piece of shit, you fucking cockroach.mp3","")
	insertSoundFile(2, 640, "You ain't all that, and a bag of potato chips.mp3","")
	insertSoundFile(2, 641, "You all suck.mp3","")
	insertSoundFile(2, 642, "You are a bitch.mp3","")
	insertSoundFile(2, 643, "You are a smelly pirate hooker.mp3","")
	insertSoundFile(2, 644, "You are absolutely right, you do suck.mp3","")
	insertSoundFile(2, 645, "You are by far the dumbest most pathetic EXTREME INSULT.mp3","")
	insertSoundFile(2, 646, "You are normally very stupid, but this time you have devised a very good plan.mp3","")
	insertSoundFile(2, 647, "You are nothing.mp3","")
	insertSoundFile(2, 648, "You are pukes, you are the lowest form of life on EARTH.mp3","")
	insertSoundFile(2, 649, "You are ugly when you're angry.mp3","")
	insertSoundFile(2, 650, "You ask stupid questions.mp3","")
	insertSoundFile(2, 651, "You asshole.mp3","")
	insertSoundFile(2, 652, "You bastard.mp3","")
	insertSoundFile(2, 653, "You bastards, you vicious hartless bastards.mp3","")
	insertSoundFile(2, 654, "You better get your head and your ass together wired together, or I will take a giant shit on you.mp3","")
	insertSoundFile(2, 655, "You can do it, you can do it all night long.mp3","")
	insertSoundFile(2, 656, "You can suck my coolo chica.mp3","")
	insertSoundFile(2, 657, "You can't handle the truth.mp3","")
	insertSoundFile(2, 658, "You cannot defeat the living flame.mp3","")
	insertSoundFile(2, 659, "You cock sucker.mp3","")
	insertSoundFile(2, 660, "You do not want to face the wrath of my bunghole.mp3","")
	insertSoundFile(2, 661, "You don't listen, do ya asshole.mp3","")
	insertSoundFile(2, 662, "You don't scare me, I got chunks of guys like you in my stool.mp3","")
	insertSoundFile(2, 663, "You fell victim to one of the classic blunders.mp3","")
	insertSoundFile(2, 664, "You fucking little monkey.mp3","")
	insertSoundFile(2, 665, "You get nothing, you lose, good day sir.mp3","")
	insertSoundFile(2, 666, "You go now, no trouble.mp3","")
	insertSoundFile(2, 667, "You gonna cry, gonna cry, big man, yeah I thought so.mp3","")
	insertSoundFile(2, 668, "You gonna do something, or just stand there and bleed.mp3","")
	insertSoundFile(2, 669, "You got a small winkie.mp3","")
	insertSoundFile(2, 670, "You got knocked the fuck out man.mp3","")
	insertSoundFile(2, 671, "You got some fucking attitude, you know that.mp3","")
	insertSoundFile(2, 672, "You guys suck.mp3","")
	insertSoundFile(2, 673, "You had best not fuck yourself, or I will unscrew your head and shit down your neck.mp3","")
	insertSoundFile(2, 674, "You have a rendezvous with my ass mother fucker.mp3","")
	insertSoundFile(2, 675, "You have the ring, and I see your schwartz is as big as mine.mp3","")
	insertSoundFile(2, 676, "You have way to much pubic HAIR.mp3","")
	insertSoundFile(2, 677, "You just made a fatal mistake Mr Candy Ass.mp3","")
	insertSoundFile(2, 678, "You just watch your mouth mr.mp3","")
	insertSoundFile(2, 679, "You know there are over 50 million people on the web, and they're not all nice.mp3","")
	insertSoundFile(2, 680, "You know what, that makes me mad.mp3","")
	insertSoundFile(2, 681, "You know you like it just as much as I do.mp3","")
	insertSoundFile(2, 682, "You know, I didn't this could get any worse, but ha ha, it has.mp3","")
	insertSoundFile(2, 683, "You know, that sounds pretty sweet to me.mp3","")
	insertSoundFile(2, 684, "You know, there are people in this world that don't have to put up with all this shit.mp3","")
	insertSoundFile(2, 685, "You land lubbers are tougher than I thought, I'll have to improvise.mp3","")
	insertSoundFile(2, 686, "You leave me with no choice, I'm going to have to kick your ass.mp3","")
	insertSoundFile(2, 687, "You lie, you lieeeeeeeeee.mp3","")
	insertSoundFile(2, 688, "You magnificant bastard, I salute you.mp3","")
	insertSoundFile(2, 689, "You must be very proud of yourself.mp3","")
	insertSoundFile(2, 690, "You people are fucking sick.mp3","")
	insertSoundFile(2, 691, "You pompoous stuck up dick face asshole INSULT.mp3","")
	insertSoundFile(2, 692, "You should have stayed at home today.mp3","")
	insertSoundFile(2, 693, "You sick bastard.mp3","")
	insertSoundFile(2, 694, "You sick little monkey.mp3","")
	insertSoundFile(2, 695, "You snotty faced heap of parrot dropping.mp3","")
	insertSoundFile(2, 696, "You son of a bitch, your mom sucks.mp3","")
	insertSoundFile(2, 697, "You stupid fucking cunt.mp3","")
	insertSoundFile(2, 698, "You stupid son of a bitch.mp3","")
	insertSoundFile(2, 699, "You suck, ya jackass.mp3","")
	insertSoundFile(2, 700, "You use your tongue prettier than a 20 dollar whore.mp3","")
	insertSoundFile(2, 701, "You wanna get high.mp3","")
	insertSoundFile(2, 702, "You wanna go.mp3","")
	insertSoundFile(2, 703, "You weak pathetic fool.mp3","")
	insertSoundFile(2, 704, "You were good kid, real good, but as long as I'm around, you'll always be second best see.mp3","")
	insertSoundFile(2, 705, "You would need three promotions to get to be an asshole.mp3","")
	insertSoundFile(2, 706, "You're a bad man, a very bad man.mp3","")
	insertSoundFile(2, 707, "You're a dead mother fucker, you understand me.mp3","")
	insertSoundFile(2, 708, "You're a god damn disgrace.mp3","")
	insertSoundFile(2, 709, "You're absolutely correct.mp3","")
	insertSoundFile(2, 710, "You're all a bunch of god damn pussies.mp3","")
	insertSoundFile(2, 711, "You're an embarrasment to nature, do you know that.mp3","")
	insertSoundFile(2, 712, "You're asking for a drive by slapping pal.mp3","")
	insertSoundFile(2, 713, "You're gonna die clown.mp3","")
	insertSoundFile(2, 714, "You're in more need of a blowjob than any white man in histoory.mp3","")
	insertSoundFile(2, 715, "You're not a freak, you're just stupid.mp3","")
	insertSoundFile(2, 716, "You're not the same, I'm an American, you're a sick asshole.mp3","")
	insertSoundFile(2, 717, "You're perfect, better than perfect, perfection is CRAP.mp3","")
	insertSoundFile(2, 718, "You're so ugly you could be a modern art masterpiece.mp3","")
	insertSoundFile(2, 719, "You're such a genius.mp3","")
	insertSoundFile(2, 720, "You're the king, well I didn't vote for you.mp3","")
	insertSoundFile(2, 721, "You, you're ok, this one, real fucking ugly.mp3","")
	insertSoundFile(2, 722, "Your ass ain't taking your way outta this shit.mp3","")
	insertSoundFile(2, 723, "Your balls are filthy, go to the ball washer now.mp3","")
	insertSoundFile(2, 724, "Your balls are showing.mp3","")
	insertSoundFile(2, 725, "Your momma puts out on weekends.mp3","")
	insertSoundFile(2, 726, "Your move creep.mp3","")
end

function toggleWowSounds()
	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Before:" .. GetCVar("Sound_EnableAllSound"))
	end

	local allSoundIsEnabled = GetCVar("Sound_EnableAllSound")
	--SetCVar("Sound_EnableAllSound", 0)
	--SetCVar("Sound_EnableAllSound", old)

	if (allSoundIsEnabled == "1") then -- if all sound is enabled, turn it off
		DEFAULT_CHAT_FRAME:AddMessage("WoW Sound Is Now Disabled",0,1,0)
		SetCVar("Sound_EnableAllSound", "0")
	elseif (allSoundIsEnabled == "0") then  -- if all sound is disabled, turn it on
		DEFAULT_CHAT_FRAME:AddMessage("WoW Sound Is Now Enabled",0,1,0)
		SetCVar("Sound_EnableAllSound", "1")
		DD_playThisSoundFile(1)
	end

	if DEBUG >= 1 then
		DEFAULT_CHAT_FRAME:AddMessage("After:" .. GetCVar("Sound_EnableAllSound"))
	end
end







--[[
	Binary Search a Table
	Binary Insert into Table (faster than table.insert and table.sort combined)
	v 0.3

	Lua 5.1 compatible
]]--
--[[
	table.binsearch( table, value [, compval [, reversed] ] )

	Searches the table through BinarySearch for the given value.
	If the  value is found:
		it returns a table holding all the mathing indices (e.g. { startindice,endindice } )
		endindice may be the same as startindice if only one matching indice was found
	If compval is given:
		then it must be a function that takes one value and returns a second value2,
		to be compared with the input value, e.g.:
		compvalue = function( value ) return value[1] end
	If reversed is set to true:
		then the search assumes that the table is sorted in reverse order (largest value at position 1)
		note when reversed is given compval must be given as well, it can be nil/_ in this case
	Return value:
		on success: a table holding matching indices (e.g. { startindice,endindice } )
		on failure: nil
]]--
--[[
do
	-- Avoid heap allocs for performance
	local default_fcompval = function( value ) return value end
	local fcompf = function( a,b ) return a < b end
	local fcompr = function( a,b ) return a > b end
	function table.binsearch( t,value,fcompval,reversed )
		-- Initialise functions
		local fcompval = fcompval or default_fcompval
		local fcomp = reversed and fcompr or fcompf
		--  Initialise numbers
		local iStart,iEnd,iMid = 1,#t,0
		-- Binary Search
		while iStart <= iEnd do
			-- calculate middle
			iMid = math.floor( (iStart+iEnd)/2 )
			-- get compare value
			local value2 = fcompval( t[iMid] )
			-- get all values that match
			if value == value2 then
				local tfound,num = { iMid,iMid },iMid - 1
				while value == fcompval( t[num] ) do
					tfound[1],num = num,num - 1
				end
				num = iMid + 1
				while value == fcompval( t[num] ) do
					tfound[2],num = num,num + 1
				end
				return tfound
			-- keep searching
			elseif fcomp( value,value2 ) then
				iEnd = iMid - 1
			else
				iStart = iMid + 1
			end
		end
	end
end
]]--
--[[
	table.bininsert( table, value [, comp] )

	Inserts a given value through BinaryInsert into the table sorted by [, comp].

	If 'comp' is given, then it must be a function that receives
	two table elements, and returns true when the first is less
	than the second, e.g. comp = function(a, b) return a > b end,
	will give a sorted table, with the biggest value on position 1.
	[, comp] behaves as in table.sort(table, value [, comp])
	returns the index where 'value' was inserted
]]--
--[[
do
	-- Avoid heap allocs for performance
	DEFAULT_CHAT_FRAME:AddMessage(a)
	DEFAULT_CHAT_FRAME:AddMessage(a)
	local fcomp_default = function( a,b ) return a < b end

	function table.bininsert(t, value, fcomp)
		-- Initialise compare function
		local fcomp = fcomp or fcomp_default
		--  Initialise numbers
		local iStart,iEnd,iMid,iState = 1,#t,1,0
		-- Get insert position
		while iStart <= iEnd do
			-- calculate middle
			iMid = math.floor( (iStart+iEnd)/2 )
			-- compare
			if fcomp( value,t[iMid] ) then
				iEnd,iState = iMid - 1,0
			else
				iStart,iState = iMid + 1,1
			end
		end
		table.insert( t,(iMid+iState),value )
		return (iMid+iState)
	end
end
-- CHILLCODE
]]--

